searchData={"items":[{"type":"module","title":"Backpex","doc":"Backpex provides an easy way to manage existing resources in your application.","ref":"Backpex.html"},{"type":"function","title":"Backpex.translate/2","doc":"Translates a string.\n\nThe type must be `:genral` or `:error`.","ref":"Backpex.html#translate/2"},{"type":"module","title":"Backpex.CookieController","doc":"","ref":"Backpex.CookieController.html"},{"type":"function","title":"Backpex.CookieController.update/2","doc":"","ref":"Backpex.CookieController.html#update/2"},{"type":"module","title":"Backpex.Ecto.Amount.Type","doc":"Provides a type for Ecto to store a amount.\nThe underlying data type should be an integer.","ref":"Backpex.Ecto.Amount.Type.html"},{"type":"module","title":"Migration - Backpex.Ecto.Amount.Type","doc":"create table(:my_table) do\n      add :amount, :integer\n    end","ref":"Backpex.Ecto.Amount.Type.html#module-migration"},{"type":"module","title":"Schema - Backpex.Ecto.Amount.Type","doc":"schema \"my_table\" do\n      field :amount, Backpex.Ecto.Amount.Type\n    end\n\n    schema \"my_table\" do\n      field :amount, Backpex.Ecto.Amount.Type, currency: :EUR, separator: \".\", delimiter: \",\"\n    end","ref":"Backpex.Ecto.Amount.Type.html#module-schema"},{"type":"function","title":"Backpex.Ecto.Amount.Type.cast/2","doc":"","ref":"Backpex.Ecto.Amount.Type.html#cast/2"},{"type":"function","title":"Backpex.Ecto.Amount.Type.dump/3","doc":"","ref":"Backpex.Ecto.Amount.Type.html#dump/3"},{"type":"function","title":"Backpex.Ecto.Amount.Type.init/1","doc":"","ref":"Backpex.Ecto.Amount.Type.html#init/1"},{"type":"function","title":"Backpex.Ecto.Amount.Type.load/3","doc":"","ref":"Backpex.Ecto.Amount.Type.html#load/3"},{"type":"function","title":"Backpex.Ecto.Amount.Type.type/1","doc":"","ref":"Backpex.Ecto.Amount.Type.html#type/1"},{"type":"module","title":"Backpex.FormComponent","doc":"The form live component.","ref":"Backpex.FormComponent.html"},{"type":"function","title":"Backpex.FormComponent.handle_event/3","doc":"","ref":"Backpex.FormComponent.html#handle_event/3"},{"type":"function","title":"Backpex.FormComponent.render/1","doc":"","ref":"Backpex.FormComponent.html#render/1"},{"type":"function","title":"Backpex.FormComponent.update/2","doc":"","ref":"Backpex.FormComponent.html#update/2"},{"type":"module","title":"Backpex.InitAssigns","doc":"Ensures Backpex `assigns` are applied to all LiveViews attaching this hook.","ref":"Backpex.InitAssigns.html"},{"type":"function","title":"Backpex.InitAssigns.on_mount/4","doc":"","ref":"Backpex.InitAssigns.html#on_mount/4"},{"type":"behaviour","title":"Backpex.LiveResource","doc":"LiveResource makes it easy to manage existing resources in your application.\nIt provides extensive configuration options in order to meet everyone's needs.\nIn connection with `Backpex.Components` you can build an individual admin dashboard\non top of your application in minutes.","ref":"Backpex.LiveResource.html"},{"type":"behaviour","title":"Example - Backpex.LiveResource","doc":"Before you start make sure Backpex is properly configured.\n\n`Backpex.LiveResource` is the module that will generate the corresponding LiveViews for the resource you configured.\nYou are required to set some general options to tell Backpex where to find the resource and what\nchangesets should be used. In addition you have to provide names and a list of fields.\n\nA minimal configuration looks something like this:\n\n    defmodule MyAppWeb.UserLive do\n      use Backpex.LiveResource,\n        layout: {MyAppWeb.LayoutView, :admin},\n        schema: MyApp.User,\n        repo: MyApp.Repo,\n        update_changeset: &MyApp.User.update_changeset/3,\n        create_changeset: &MyApp.User.create_changeset/3\n\n      @impl Backpex.LiveResource\n      def singular_name(), do: \"User\"\n\n      @impl Backpex.LiveResource\n      def plural_name(), do: \"Users\"\n\n      @impl Backpex.LiveResource\n      def fields do\n      [\n        username: %{\n          module: Backpex.Fields.Text,\n          label: \"Username\"\n        },\n        first_name: %{\n          module: Backpex.Fields.Text,\n          label: \"First Name\"\n        },\n        last_name: %{\n          module: Backpex.Fields.Text,\n          label: \"Last Name\"\n        },\n      ]\n    end\n\nYou are also required to configure your router in order to serve the generated LiveViews:\n\n    defmodule MyAppWeb.Router\n      import Backpex.Router\n\n      scope \"/admin\", MyAppWeb do\n        pipe_through :browser\n\n        live_session :default, on_mount: Backpex.InitAssigns do\n          live_resources(\"/users\", UserLive)\n        end\n      end\n    end\n\n> #### `use Backpex.LiveResource` {: .info}\n>\n> When you `use Backpex.LiveResource`, the `Backpex.LiveResource` module will set `@behavior Backpex.LiveResource`. Additionally it will create a LiveView based on the given configuration in order to create fully functional index, show, new and edit views for a resource. It will also insert fallback functions that can be overridden.","ref":"Backpex.LiveResource.html#module-example"},{"type":"behaviour","title":"Define a resource - Backpex.LiveResource","doc":"To explain configuration settings we created an event schema with a corresponding `EventLive` configuration file.\n\n    defmodule MyAppWeb.EventLive do\n      alias MyApp.Event\n\n      use Backpex.LiveResource,\n        layout: {MyAppWeb.LayoutView, :admin}, # Specify the layout you created in the step before\n        schema: Event, # Schema of the resource\n        repo: MyApp.Repo, # Ecto repository\n        update_changeset: &Event.update_changeset/3, # Changeset to be used for update queries\n        create_changeset: &Event.create_changeset/3,  # Changeset to be used for create queries\n        pubsub: Demo.PubSub, # PubSub name of the project.\n        topic: \"events\", # The topic for PubSub\n        event_prefix: \"event_\", # The event prefix for Pubsub, to differentiate between events of different resources when subscribed to multiple resources\n        fluid?: true # Optional to define if your resource should be rendered full width. Depends on the your [layout configuration](installation.md)\n\n      # Singular name to displayed on the resource page\n      @impl Backpex.LiveResource\n      def singular_name(), do: \"Event\"\n\n      # Plural name to displayed on the resource page\n      @impl Backpex.LiveResource\n      def plural_name(), do: \"Events\"\n\n      # Field configurations\n      # Here can configure which fields of the schema should be displayed on your dashboard.\n      # Backpex provides certain field modules that may be used for displaying the field on index and form views.\n      # You may define you own module or overwrite the render functions in this configuration (`render` for index views\n      # and `render_form` for form views).\n      @impl Backpex.LiveResource\n      def fields do\n        [\n          # The title field of our event schema\n          title: %{\n            module: Backpex.Fields.Text,\n            label: \"Title\"\n          },\n          # The location field of our event schema. It should not be displayed on `:edit` view.\n          location: %{\n            module: Backpex.Fields.Text,\n            label: \"Location\",\n            except: [:edit]\n          },\n          # The location field of our event schema. We use the Backpex URL module in order to make the url clickable.\n          # This field is only displayed on `:index` view.\n          url: %{\n            module: Backpex.Fields.URL,\n            label: \"Url\",\n            only: [:index]\n          },\n          # The begins_at field of our event schema. We provide or own render function to display this field on index views.\n          # The value can be extracted from the assigns.\n          begins_at: %{\n            module: Backpex.Fields.Date,\n            label: \"Begins At\",\n            render: fn assigns ->\n              ~H\"\"\"\n               \n                <%= @value %>\n               \n              \"\"\"\n            end\n          },\n          # The ends_at field of our event schema. This field should not be sortable.\n          ends_at: %{\n            module: Backpex.Fields.Date,\n            label: \"Ends at\"\n          },\n          # The published field of our url schema. We use the boolean field to display a switch button on edit views.\n          published: %{\n            module: Backpex.Fields.Boolean,\n            label: \"Published\",\n            sortable: false\n          }\n        ]\n      end\n    end","ref":"Backpex.LiveResource.html#module-define-a-resource"},{"type":"behaviour","title":"Templates - Backpex.LiveResource","doc":"You are able to customize certain parts of Backpex. While you may use our app shell layout only you may also define functions to provide additional templates to be rendered on the resource LiveView or completely overwrite certain parts like the header or main content.\n\nSee [render_resource_slot/3](Backpex.LiveResource.html#c:render_resource_slot/3) for supported positions.\n\n**Example:**\n    # in your resource configuration file\n\n    # to add content above main on index view\n    def render_resource_slot(assigns, :index, :before_main), do: ~H\"Hello World!\"","ref":"Backpex.LiveResource.html#module-templates"},{"type":"behaviour","title":"Item Query - Backpex.LiveResource","doc":"It is possible to manipulate the query when fetching resources for `index`, `show` and `edit` view by defining an `item_query` function.\n\nIn all queries we define a `from` query with a named binding to fetch all existing resources on `index` view or a specific resource on `show` / `edit` view.\nAfter that, we call the `item_query` function. By default this returns the incoming query.\n\nThe `item_query` function makes it easy to add custom query expressions.\n\nFor example, you could filter posts by a published boolean on `index` view.\n\n    # in your resource configuration file\n\n    @impl Backpex.LiveResource\n    def item_query(query, :index, _assigns) do\n    query\n    |> where([post], post.published)\n    end\n\nIn this example we also made use of the named binding. It's always the name of the provided schema in `snake_case`.\nIt is recommended to build your `item_query` on top of the incoming query. Otherwise you will likely get binding errors.","ref":"Backpex.LiveResource.html#module-item-query"},{"type":"behaviour","title":"Authorize Actions - Backpex.LiveResource","doc":"Use `can?(_assigns, _action, _item)` function in you resource configuration to limit access to item actions\n(Actions: `:index`, `:new`, `:show`, `:edit`, `:delete`, `:your_item_action_key`, `:your_resource_action_key`).\nThe function is not required and returns `true` by default.\nThe item is `nil` for any action that does not require an item to be performed (`:index`, `:new`, `:your_resource_action_key`).\n\n**Examples:**\n    # _item is nil for any action that does not require an item to be performed\n    def can?(_assigns, :new, _item), do: false\n\n    def can?(_assigns, :my_item_action, item), do: item.role == :admin\n\n    def can?(assigns, :my_resource_action, nil), do: assigns.current_user == :admin\n\n> Note that item actions are always displayed if they are defined. If you want to remove item actions completely, you must restrict access to them with `can?/3` and remove the action with the `item_actions/1` function.","ref":"Backpex.LiveResource.html#module-authorize-actions"},{"type":"behaviour","title":"Resource Actions - Backpex.LiveResource","doc":"You may define actions for certain resources in order to integrate complex processes into Backpex.\n\nAction routes are automatically generated when using the `live_resources` macro.\n\nFor example you could add an invite process to your user resource as shown in the following.\n\n```elixir\ndefmodule MyAppWeb.Admin.Actions.Invite do\n  use Backpex.ResourceAction\n\n  import Ecto.Changeset\n\n  @impl Backpex.ResourceAction\n  def label, do: \"Invite\"\n\n  @impl Backpex.ResourceAction\n  def title, do: \"Invite user\"\n\n  # you can reuse Backpex fields in the field definition\n  @impl Backpex.ResourceAction\n  def fields do\n    [\n      email: %{\n        module: Backpex.Fields.Text,\n        label: \"Email\",\n        type: :string\n      }\n    ]\n  end\n\n  @required_fields ~w[email]a\n\n  @impl Backpex.ResourceAction\n  def changeset(change, attrs) do\n    change\n    |> cast(attrs, @required_fields)\n    |> validate_required(@required_fields)\n    |> validate_email(:email)\n  end\n\n  # your action to be performed\n  @impl Backpex.ResourceAction\n  def handle(_socket, params) do\n    # Send mail\n\n    # We suppose there was no error.\n    if true do\n      {:ok, \"An email to #{params[:email]} was sent successfully.\"}\n    else\n      {:error, \"An error occurred while sending an email to  #{params[:email]}!\"}\n    end\n  end\nend\n```\n\n```elixir\n# in your resource configuration file\n\n# each action consists out of an unique id and the corresponding action module\n@impl Backpex.LiveResource\ndef resource_actions() do\n[\n  %{\n    module: MyWebApp.Admin.ResourceActions.Invite,\n    id: :invite\n  }\n]\nend\n```","ref":"Backpex.LiveResource.html#module-resource-actions"},{"type":"behaviour","title":"Ordering - Backpex.LiveResource","doc":"You may provide an `init_order` option to specify how the initial index page is being ordered.\n\n    # in your resource configuration file\n\n    use Backpex.LiveResource,\n      ...,\n      init_order: %{by: :inserted_at, direction: :desc}\n\n      # Routing","ref":"Backpex.LiveResource.html#module-ordering"},{"type":"behaviour","title":"Routing - Backpex.LiveResource","doc":"You are required to configure your router in order to point to the resources created in before steps.\nMake sure to use the `Backpex.InitAssigns` hook to ensure all Backpex assigns are applied to the LiveViews.\n\nYou have to use the `Backpex.Router.live_resources/3` macro to generate routes for your resources.\n\n    # MyAppWeb.Router\n\n    import Backpex.Router\n\n    scope \"/admin\", MyAppWeb do\n    pipe_through :browser\n\n    live_session :default, on_mount: Backpex.InitAssigns do\n      live_resources(\"/events\", EventLive)\n    end\n\nIn addition you have to use the `Backpex.Router.backpex_routes` macro. It will add some more routes at base scope. You can place this anywhere in your router.\nWe will mainly use this routes to insert a `Backpex.CookieController`. We need it in order to save some user related settings (e.g. which columns on index view you selected to be active).\n\n    # MyAppWeb.Router\n\n    import Backpex.Router\n\n    scope \"/\" do\n      pipe_through :browser\n\n      backpex_routes()\n    end","ref":"Backpex.LiveResource.html#module-routing"},{"type":"behaviour","title":"Searching - Backpex.LiveResource","doc":"You may flag fields as searchable. A search input will appear automatically on the resource index view.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        %{\n          ...,\n          searchable: true\n        }\n      ]\n    end\n\nFor a custom placeholder, you can use the `elixir search_placeholder/0` callback.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def search_placeholder, do: \"This will be shown in the search input.\"\n\nIn addition to basic searching, Backpex allows you to perform full-text searches on resources (see [Full-Text Search Guide](full_text_search.md)).","ref":"Backpex.LiveResource.html#module-searching"},{"type":"behaviour","title":"Hooks - Backpex.LiveResource","doc":"You may define hooks that are called after their respective action. Those hooks are `on_item_created`, `on_item_updated` and `on_item_deleted`.\nThese methods receive the socket and the corresponding item and are expected to return a socket.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def on_item_created(socket, item) do\n      # send an email on user creation\n      socket\n    end","ref":"Backpex.LiveResource.html#module-hooks"},{"type":"behaviour","title":"PubSub - Backpex.LiveResource","doc":"PubSub settings are required in order to support live updates.\n\n    # in your resource configuration file\n    use Backpex.LiveResource,\n        ...,\n        pubsub: Demo.PubSub, # PubSub name of the project.\n        topic: \"events\", # The topic for PubSub\n        event_prefix: \"event_\" # The event prefix for Pubsub, to differentiate between events of different resources when subscribed to multiple resources\n\nIn addition you may react to `...deleted`, `...updated` and `...created` events via `handle_info`\n\n    # in your resource configuration file\n    @impl Phoenix.LiveView\n    def handle_info({\"event_created\", item}, socket) do\n      # make something in response to the event, for example show a toast to all users currently on the resource that an event has been created.\n      {:noreply, socket}\n    end","ref":"Backpex.LiveResource.html#module-pubsub"},{"type":"behaviour","title":"Navigation - Backpex.LiveResource","doc":"You may define a custom navigation path that is called after the item is saved.\nThe method receives the socket, the live action and the corresponding item and is expected to return a route path.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def return_to(socket, assigns, _action, _item) do\n      # return to user index after saving\n      Routes.user_path(socket, :index)\n    end","ref":"Backpex.LiveResource.html#module-navigation"},{"type":"behaviour","title":"Panels - Backpex.LiveResource","doc":"You are able to define panels to group certain fields together. Panels are displayed in the provided order.\nThe `Backpex.LiveResource.panels/0` function has to return a keyword list with an identifier and label for each panel.\nYou can move fields into panels with the `panel` field configuration that has to return the identifier of the corresponding panel. Fields without a panel are displayed in the `:default` panel. The `:default` panel has no label.\n\n> Note that a panel is not displayed when there are no fields in it.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def panels do\n      [\n        contact: \"Contact\"\n      ]\n    end\n\n    # in your fields list\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        %{\n          ...,\n          panel: :contact\n        }\n      ]\n    end","ref":"Backpex.LiveResource.html#module-panels"},{"type":"behaviour","title":"Default values - Backpex.LiveResource","doc":"It is possible to assign default values to fields.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        username: %{\n          default: fn _assigns -> \"Default Username\" end\n        }\n      ]\n    end\n\n> Note that default values are set when creating new resources only.","ref":"Backpex.LiveResource.html#module-default-values"},{"type":"behaviour","title":"Alignment - Backpex.LiveResource","doc":"You may align fields on index view. By default fields are aligned to the left.\n\nWe currently support the following alignments: `:left`, `:center` and `:right`.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        %{\n          ...,\n          align: :center\n        }\n      ]\n    end\n\nIn addition to field alignment, you can align the labels on form views (`index`, `edit`, `resource_action`) using the `align_label` field option.\n\nWe currently support the following label orientations: `:top`, `:center` and `:bottom`.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        %{\n          ...,\n          align_label: :top\n        }\n      ]\n    end","ref":"Backpex.LiveResource.html#module-alignment"},{"type":"behaviour","title":"Fields Visibility - Backpex.LiveResource","doc":"You are able to change visibility of fields based on certain conditions (`assigns`).\n\nImagine you want to implement a checkbox in order to toggle an input field (post likes). Initially, the input field should be visible when it has a certain value (post likes > 0).\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def fields do\n      [\n        # show_likes is a virtual field in the post schema\n        show_likes: %{\n          module: Backpex.Fields.Boolean,\n          label: \"Show likes\",\n          # initialize the button based on the likes value\n          select: dynamic([post: p], fragment(\"? > 0\", p.likes)),\n        },\n        likes: %{\n          module: Backpex.Fields.Number,\n          label: \"Likes\",\n          # display the field based on the `show_likes` value\n          # the value can be part of the changeset or item (when edit view is opened initially).\n          visible: fn\n            %{live_action: :new} = assigns ->\n              Map.get(assigns.changeset.changes, :show_likes)\n\n            %{live_action: :edit} = assigns ->\n              Map.get(assigns.changeset.changes, :show_likes, Map.get(assigns.item, :show_likes, false))\n\n            _assigns ->\n              true\n          end\n        }\n      ]\n    end\n\n> Note that hidden fields are not exempt from validation by Backpex itself and the visible function is not executed on `:index`.\n\nIn addition to `visible/1`, we provide a `can?1` function that you can use to determine the visibility of a field.\nIt can also be used on `:index` and takes the `assigns` as a parameter.\n\n    # in your resource configuration file\n    inserted_at: %{\n      module: Backpex.Fields.DateTime,\n      label: \"Created At\",\n      can?: fn\n        %{live_action: :show} = _assigns ->\n          true\n\n        _assigns ->\n          false\n      end\n    }","ref":"Backpex.LiveResource.html#module-fields-visibility"},{"type":"behaviour","title":"Tooltips - Backpex.LiveResource","doc":"We support tooltips via [daisyUI](https://daisyui.com/components/tooltip/).","ref":"Backpex.LiveResource.html#module-tooltips"},{"type":"behaviour","title":"Index Editable - Backpex.LiveResource","doc":"A small number of fields support index editable. These fields can be edited inline on the index view.\n\nYou must enable index editable for a field.\n\n    # in your resource configuration file\n    def fields do\n      [\n        name: %{\n          module: Backpex.Fields.Text,\n          label: \"Name\",\n          index_editable: true\n        }\n      ]\n    end\n\nCurrently supported by the following fields:\n- `Backpex.Fields.Number`\n- `Backpex.Fields.Select`\n- `Backpex.Fields.Text`\n\n> Note you can add index editable support to your custom fields by defining the `render_index_form/1` function and enabling index editable for your field.","ref":"Backpex.LiveResource.html#module-index-editable"},{"type":"macro","title":"Backpex.LiveResource.__using__/1","doc":"Uses LiveResource in the current module to make it a LiveResource.\n\n    use Backpex.LiveResource,\n      layout: {MyAppWeb.LayoutView, :admin},\n      schema: MyApp.User,\n      repo: MyApp.Repo,\n      update_changeset: &MyApp.User.update_changeset/3,\n      create_changeset: &MyApp.User.create_changeset/3","ref":"Backpex.LiveResource.html#__using__/1"},{"type":"macro","title":"Options - Backpex.LiveResource.__using__/1","doc":"* `:layout` - Layout to be used by the LiveResource.\n  * `:schema` - Schema for the resource.\n  * `:repo` - Ecto repo that will be used to perform CRUD operations for the given schema.\n  * `:update_changeset` - Changeset to use when updating items. Additional metadata is passed as a keyword list via the third parameter.\n\n    The list of metadata:\n    - `:assigns` - the assigns\n    - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.\n  * `:create_changeset` - Changeset to use when creating items. Additional metadata is passed as a keyword list via the third parameter.\n\n    The list of metadata:\n    - `:assigns` - the assigns\n    - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.\n  * `:pubsub` - PubSub name of the project.\n  * `:topic` - The topic for PubSub.\n  * `:event_prefix` - The event prefix for Pubsub, to differentiate between events of different resources when subscribed to multiple resources.\n  * `:per_page_options` - The page size numbers you can choose from.\n    Defaults to `[15, 50, 100]`.\n  * `:per_page_default` - The default page size number.\n    Defaults to the first element of the `per_page_options` list.\n  * `:init_order` - Order that will be used when no other order options are given.\n    Defaults to `%{by: :id, direction: :asc}`.","ref":"Backpex.LiveResource.html#__using__/1-options"},{"type":"function","title":"Backpex.LiveResource.calculate_total_pages/2","doc":"Calculates the total amount of pages.","ref":"Backpex.LiveResource.html#calculate_total_pages/2"},{"type":"function","title":"Examples - Backpex.LiveResource.calculate_total_pages/2","doc":"iex> Backpex.LiveResource.calculate_total_pages(1, 2)\n    1\n    iex> Backpex.LiveResource.calculate_total_pages(10, 10)\n    1\n    iex> Backpex.LiveResource.calculate_total_pages(20, 10)\n    2\n    iex> Backpex.LiveResource.calculate_total_pages(25, 6)\n    5","ref":"Backpex.LiveResource.html#calculate_total_pages/2-examples"},{"type":"function","title":"Backpex.LiveResource.call_changeset_function/5","doc":"Calls the changeset function with the given change and target.","ref":"Backpex.LiveResource.html#call_changeset_function/5"},{"type":"callback","title":"Backpex.LiveResource.can?/3","doc":"The function that can be used to restrict access to certain actions. It will be called before performing\nan action and aborts when the function returns `false`.","ref":"Backpex.LiveResource.html#c:can?/3"},{"type":"function","title":"Backpex.LiveResource.can?/4","doc":"Checks whether user is allowed to perform provided action or not","ref":"Backpex.LiveResource.html#can?/4"},{"type":"function","title":"Backpex.LiveResource.default_item_actions/0","doc":"","ref":"Backpex.LiveResource.html#default_item_actions/0"},{"type":"callback","title":"Backpex.LiveResource.fields/0","doc":"A list of fields defining your resource. See `Backpex.Field`.","ref":"Backpex.LiveResource.html#c:fields/0"},{"type":"function","title":"Backpex.LiveResource.filter_field_by_action/2","doc":"Filters a field by a given action. It checks whether the field contains the only or\nexcept key and decides whether or not to keep the field.","ref":"Backpex.LiveResource.html#filter_field_by_action/2"},{"type":"function","title":"Examples - Backpex.LiveResource.filter_field_by_action/2","doc":"iex> Backpex.LiveResource.filter_field_by_action(%{only: [:index]}, :index)\n    true\n    iex> Backpex.LiveResource.filter_field_by_action(%{only: [:edit]}, :index)\n    false\n    iex> Backpex.LiveResource.filter_field_by_action(%{except: [:edit]}, :index)\n    true\n    iex> Backpex.LiveResource.filter_field_by_action(%{except: [:index]}, :index)\n    false","ref":"Backpex.LiveResource.html#filter_field_by_action/2-examples"},{"type":"function","title":"Backpex.LiveResource.filter_options/2","doc":"Returns all filter options.","ref":"Backpex.LiveResource.html#filter_options/2"},{"type":"function","title":"Backpex.LiveResource.filtered_fields_by_action/3","doc":"Returns filtered fields by a certain action.","ref":"Backpex.LiveResource.html#filtered_fields_by_action/3"},{"type":"function","title":"Example - Backpex.LiveResource.filtered_fields_by_action/3","doc":"iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\"}, field2: %{label: \"Field2\"}], %{}, :index)\n    [field1: %{label: \"Field1\"}, field2: %{label: \"Field2\"}]\n    iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\", except: [:show]}, field2: %{label: \"Field2\"}], %{}, :show)\n    [field2: %{label: \"Field2\"}]\n    iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\", only: [:index]}, field2: %{label: \"Field2\"}], %{}, :show)\n    [field2: %{label: \"Field2\"}]","ref":"Backpex.LiveResource.html#filtered_fields_by_action/3-example"},{"type":"callback","title":"Backpex.LiveResource.filters/0","doc":"A optional keyword list of [filters](filters.html) to be used on the index view.","ref":"Backpex.LiveResource.html#c:filters/0"},{"type":"callback","title":"Backpex.LiveResource.filters/1","doc":"A optional keyword list of [filters](filters.html) to be used on the index view.","ref":"Backpex.LiveResource.html#c:filters/1"},{"type":"function","title":"Backpex.LiveResource.get_active_filters/2","doc":"Returns list of active filters.","ref":"Backpex.LiveResource.html#get_active_filters/2"},{"type":"function","title":"Backpex.LiveResource.get_filter_options/2","doc":"Returns list of filter options from query options","ref":"Backpex.LiveResource.html#get_filter_options/2"},{"type":"function","title":"Backpex.LiveResource.get_valid_filters_from_params/3","doc":"","ref":"Backpex.LiveResource.html#get_valid_filters_from_params/3"},{"type":"callback","title":"Backpex.LiveResource.item_actions/1","doc":"A list of [item_actions](item_actions.html) that may be performed on (selected) items.","ref":"Backpex.LiveResource.html#c:item_actions/1"},{"type":"callback","title":"Backpex.LiveResource.item_query/3","doc":"The function that can be used to inject an ecto query. The query will be used when resources are being fetched. This happens on `index`, `edit`\nand `show` view. In most cases this function will be used to filter items on `index` view based on certain criteria, but it may also be used\nto join other tables on `edit` or `show` view.\n\nThe function has to return an `Ecto.Query`. It is recommended to build your `item_query` on top of the incoming query. Otherwise you will likely get binding errors.","ref":"Backpex.LiveResource.html#c:item_query/3"},{"type":"function","title":"Backpex.LiveResource.list_items/3","doc":"List all items for current page with filters and search applied.","ref":"Backpex.LiveResource.html#list_items/3"},{"type":"function","title":"Backpex.LiveResource.maybe_put_empty_filter/2","doc":"","ref":"Backpex.LiveResource.html#maybe_put_empty_filter/2"},{"type":"function","title":"Backpex.LiveResource.maybe_subscribe/2","doc":"Maybe subscribes to pubsub.","ref":"Backpex.LiveResource.html#maybe_subscribe/2"},{"type":"callback","title":"Backpex.LiveResource.metrics/0","doc":"A list of metrics shown on the index view of your resource.","ref":"Backpex.LiveResource.html#c:metrics/0"},{"type":"callback","title":"Backpex.LiveResource.on_item_created/2","doc":"This function is executed when an item has been created.","ref":"Backpex.LiveResource.html#c:on_item_created/2"},{"type":"callback","title":"Backpex.LiveResource.on_item_deleted/2","doc":"This function is executed when an item has been deleted.","ref":"Backpex.LiveResource.html#c:on_item_deleted/2"},{"type":"callback","title":"Backpex.LiveResource.on_item_updated/2","doc":"This function is executed when an item has been updated.","ref":"Backpex.LiveResource.html#c:on_item_updated/2"},{"type":"function","title":"Backpex.LiveResource.order_options_by_params/4","doc":"Returns order options by params.","ref":"Backpex.LiveResource.html#order_options_by_params/4"},{"type":"function","title":"Examples - Backpex.LiveResource.order_options_by_params/4","doc":"iex> Backpex.LiveResource.order_options_by_params(%{\"order_by\" => \"field\", \"order_direction\" => \"asc\"}, [field: %{}], %{by: :id, direction: :asc}, [:asc, :desc])\n    %{order_by: :field, order_direction: :asc}\n    iex> Backpex.LiveResource.order_options_by_params(%{}, [field: %{}], %{by: :id, direction: :desc}, [:asc, :desc])\n    %{order_by: :id, order_direction: :desc}\n    iex> Backpex.LiveResource.order_options_by_params(%{\"order_by\" => \"field\", \"order_direction\" => \"asc\"}, [field: %{orderable: false}], %{by: :id, direction: :asc}, [:asc, :desc])\n    %{order_by: :id, order_direction: :asc}","ref":"Backpex.LiveResource.html#order_options_by_params/4-examples"},{"type":"function","title":"Backpex.LiveResource.orderable?/1","doc":"Checks whether a field is orderable or not.","ref":"Backpex.LiveResource.html#orderable?/1"},{"type":"function","title":"Examples - Backpex.LiveResource.orderable?/1","doc":"iex> Backpex.LiveResource.orderable?({:name, %{orderable: true}})\n    true\n    iex> Backpex.LiveResource.orderable?({:name, %{orderable: false}})\n    false\n    iex> Backpex.LiveResource.orderable?({:name, %{}})\n    true\n    iex> Backpex.LiveResource.orderable?(nil)\n    false","ref":"Backpex.LiveResource.html#orderable?/1-examples"},{"type":"function","title":"Backpex.LiveResource.orderable_fields/1","doc":"Returns all orderable fields. A field is orderable by default.","ref":"Backpex.LiveResource.html#orderable_fields/1"},{"type":"function","title":"Example - Backpex.LiveResource.orderable_fields/1","doc":"iex> Backpex.LiveResource.orderable_fields([field1: %{orderable: true}])\n    [:field1]\n    iex> Backpex.LiveResource.orderable_fields([field1: %{}])\n    [:field1]\n    iex> Backpex.LiveResource.orderable_fields([field1: %{orderable: false}])\n    []","ref":"Backpex.LiveResource.html#orderable_fields/1-example"},{"type":"callback","title":"Backpex.LiveResource.panels/0","doc":"A list of panels to group certain fields together.","ref":"Backpex.LiveResource.html#c:panels/0"},{"type":"function","title":"Backpex.LiveResource.parse_integer/3","doc":"Parses integer text representation map value of the given key. If the map does not contain the given key or parsing fails\nthe default value is returned.","ref":"Backpex.LiveResource.html#parse_integer/3"},{"type":"function","title":"Examples - Backpex.LiveResource.parse_integer/3","doc":"iex> Backpex.LiveResource.parse_integer(%{number: \"1\"}, :number, 2)\n    1\n    iex> Backpex.LiveResource.parse_integer(%{number: \"abc\"}, :number, 1)\n    1","ref":"Backpex.LiveResource.html#parse_integer/3-examples"},{"type":"callback","title":"Backpex.LiveResource.plural_name/0","doc":"The plural name of the resource used for translations and titles.","ref":"Backpex.LiveResource.html#c:plural_name/0"},{"type":"function","title":"Backpex.LiveResource.pubsub_settings/3","doc":"Returns pubsub settings based on configuration.","ref":"Backpex.LiveResource.html#pubsub_settings/3"},{"type":"callback","title":"Backpex.LiveResource.render_resource_slot/3","doc":"The function that can be used to add content to certain positions on Backpex views. It may also be used to overwrite content.\n\nThe following actions are supported: `:index`, `:show`\n\nThe following positions are supported for the `:index` action: `:page_title`, `:actions`, `:filters`, `:metrics` and `:main`.\nThe following positions are supported for the `:show` action: `:page_title` and `:main`.\n\nIn addition to this, content can be inserted between the main positions via the following extra spots: `:before_page_title`, `:before_actions`, `:before_filters`, `:before_metrics` and `:before_main`.","ref":"Backpex.LiveResource.html#c:render_resource_slot/3"},{"type":"callback","title":"Backpex.LiveResource.resource_actions/0","doc":"A list of [resource_actions](resource_actions.html) that may be performed on the given resource.","ref":"Backpex.LiveResource.html#c:resource_actions/0"},{"type":"callback","title":"Backpex.LiveResource.return_to/4","doc":"This function navigates to the specified path when an item has been created or updated. Defaults to the previous resource path (index or edit).","ref":"Backpex.LiveResource.html#c:return_to/4"},{"type":"function","title":"Backpex.LiveResource.search_options/3","doc":"Returns all search options.","ref":"Backpex.LiveResource.html#search_options/3"},{"type":"callback","title":"Backpex.LiveResource.search_placeholder/0","doc":"Replaces the default placeholder for the index search.","ref":"Backpex.LiveResource.html#c:search_placeholder/0"},{"type":"function","title":"Backpex.LiveResource.searchable_fields/1","doc":"Returns all searchable fields. A field is not searchable by default.","ref":"Backpex.LiveResource.html#searchable_fields/1"},{"type":"function","title":"Example - Backpex.LiveResource.searchable_fields/1","doc":"iex> Backpex.LiveResource.searchable_fields([field1: %{searchable: true}])\n    [:field1]\n    iex> Backpex.LiveResource.searchable_fields([field1: %{}])\n    []\n    iex> Backpex.LiveResource.searchable_fields([field1: %{searchable: false}])\n    []","ref":"Backpex.LiveResource.html#searchable_fields/1-example"},{"type":"callback","title":"Backpex.LiveResource.singular_name/0","doc":"The singular name of the resource used for translations and titles.","ref":"Backpex.LiveResource.html#c:singular_name/0"},{"type":"function","title":"Backpex.LiveResource.validate_page/2","doc":"Validates a page number.","ref":"Backpex.LiveResource.html#validate_page/2"},{"type":"function","title":"Examples - Backpex.LiveResource.validate_page/2","doc":"iex> Backpex.LiveResource.validate_page(1, 5)\n    1\n    iex> Backpex.LiveResource.validate_page(-1, 5)\n    1\n    iex> Backpex.LiveResource.validate_page(6, 5)\n    5","ref":"Backpex.LiveResource.html#validate_page/2-examples"},{"type":"function","title":"Backpex.LiveResource.value_in_permitted_or_default/3","doc":"Checks whether the given value is in a list of permitted values. Otherwise return default value.","ref":"Backpex.LiveResource.html#value_in_permitted_or_default/3"},{"type":"function","title":"Examples - Backpex.LiveResource.value_in_permitted_or_default/3","doc":"iex> Backpex.LiveResource.value_in_permitted_or_default(3, [1, 2, 3], 5)\n    3\n    iex> Backpex.LiveResource.value_in_permitted_or_default(3, [1, 2], 5)\n    5","ref":"Backpex.LiveResource.html#value_in_permitted_or_default/3-examples"},{"type":"module","title":"Backpex.Resource","doc":"Generic context module for Backpex resources.","ref":"Backpex.Resource.html"},{"type":"function","title":"Backpex.Resource.apply_criteria/3","doc":"","ref":"Backpex.Resource.html#apply_criteria/3"},{"type":"function","title":"Backpex.Resource.apply_filters/3","doc":"","ref":"Backpex.Resource.html#apply_filters/3"},{"type":"function","title":"Backpex.Resource.apply_search/4","doc":"","ref":"Backpex.Resource.html#apply_search/4"},{"type":"function","title":"Backpex.Resource.count/5","doc":"Gets the total count of the current live_resource.\nPossibly being constrained the item query and the search- and filter options.","ref":"Backpex.Resource.html#count/5"},{"type":"function","title":"Backpex.Resource.delete/2","doc":"Deletes the given record from the database.\nAdditionally broadcasts the corresponding event, when PubSub is enabled.","ref":"Backpex.Resource.html#delete/2"},{"type":"function","title":"Backpex.Resource.delete_all/2","doc":"Deletes the given records from the database.\nAdditionally broadcasts the corresponding event, when PubSub is enabled.","ref":"Backpex.Resource.html#delete_all/2"},{"type":"function","title":"Backpex.Resource.get/4","doc":"Gets a database record with the given fields by the given id, possibly being enhanced by the given item_query.","ref":"Backpex.Resource.html#get/4"},{"type":"function","title":"Backpex.Resource.insert/2","doc":"Tries to insert the given changes as a new item for the current resource.\nAdditionally broadcasts the corresponding event, when PubSub is enabled.","ref":"Backpex.Resource.html#insert/2"},{"type":"function","title":"Backpex.Resource.list/4","doc":"Returns a list of items by given criteria.\n\nExample criteria:\n\n[\n  order: %{by: :item, direction: :asc},\n  pagination: %{page: 1, size: 5},\n  search: {\"hello\", [:title, :description]}\n]","ref":"Backpex.Resource.html#list/4"},{"type":"function","title":"Backpex.Resource.list_query/4","doc":"Returns the main database query for selecting a list of items by given criteria.","ref":"Backpex.Resource.html#list_query/4"},{"type":"function","title":"Backpex.Resource.metric_data/5","doc":"","ref":"Backpex.Resource.html#metric_data/5"},{"type":"function","title":"Backpex.Resource.name_by_schema/1","doc":"Gets name by schema. This is the last part of the module name as a lowercase atom.","ref":"Backpex.Resource.html#name_by_schema/1"},{"type":"function","title":"Examples - Backpex.Resource.name_by_schema/1","doc":"iex> Backpex.Resource.name_by_schema(Backpex.Resource)\n    :resource","ref":"Backpex.Resource.html#name_by_schema/1-examples"},{"type":"function","title":"Backpex.Resource.update/2","doc":"Tries to update the current item with the given changes.\nAdditionally broadcasts the corresponding event, when PubSub is enabled.","ref":"Backpex.Resource.html#update/2"},{"type":"function","title":"Backpex.Resource.update_all/4","doc":"Tries to update many items with the given changes.\nAdditionally broadcasts the corresponding event, when PubSub is enabled.","ref":"Backpex.Resource.html#update_all/4"},{"type":"behaviour","title":"Backpex.ResourceAction","doc":"Behaviour implemented by all resource action modules.","ref":"Backpex.ResourceAction.html"},{"type":"behaviour","title":"Example - Backpex.ResourceAction","doc":"defmodule MyAppWeb.Actions.Invite do\n      use Backpex.ResourceAction\n\n      import Ecto.Changeset\n\n      @impl Backpex.ResourceAction\n      def title, do: \"Invite user\"\n\n      @impl Backpex.ResourceAction\n      def label, do: \"Invite\"\n\n      @impl Backpex.ResourceAction\n      def fields do\n        [\n          email: %{\n            module: Backpex.Fields.Text,\n            label: \"Email\",\n            type: :string\n          }\n        ]\n      end\n\n      @impl Backpex.ResourceAction\n      def changeset(change, attrs) do\n        change\n        |> cast(attrs, [:email])\n        |> validate_required([:email]))\n      end\n\n      @impl Backpex.ResourceAction\n      def handle(_socket, params) do\n        # Send mail\n\n        # Success\n        {:ok, \"An email to #{params[:email]} was sent successfully.\"}\n\n        # Failure\n        {:error, \"An error occurred while sending an email to #{params[:email]}!\"}\n      end\n    end\n\n> #### `use Backpex.ResourceAction` {: .info}\n>\n> When you `use Backpex.ResourceAction`, the `Backpex.ResourceAction` module will set `@behavior Backpex.ResourceAction`.\n> In addition it will implement the `Backpex.ResourceAction.init_change` function in order to generate a schemaless changeset by default.","ref":"Backpex.ResourceAction.html#module-example"},{"type":"macro","title":"Backpex.ResourceAction.__using__/1","doc":"Defines `Backpex.ResourceAction` behaviour.","ref":"Backpex.ResourceAction.html#__using__/1"},{"type":"callback","title":"Backpex.ResourceAction.changeset/3","doc":"The changeset to be used in the resource action. It may be used to validate form inputs.\n\nAdditional metadata is passed as a keyword list via the third parameter.\n\nThe list of metadata:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","ref":"Backpex.ResourceAction.html#c:changeset/3"},{"type":"callback","title":"Backpex.ResourceAction.fields/0","doc":"A list of fields to be displayed in the resource action. See `Backpex.Field`. In addition you have to provide\na `type` for each field in order to support changeset generation.","ref":"Backpex.ResourceAction.html#c:fields/0"},{"type":"callback","title":"Backpex.ResourceAction.handle/2","doc":"The handle function for the corresponding action. It receives the params and will be called when the form is valid and submitted.\n\nIt must return either `{:ok, binary()}` or `{:error, binary()}`","ref":"Backpex.ResourceAction.html#c:handle/2"},{"type":"callback","title":"Backpex.ResourceAction.init_change/1","doc":"Initial change. The result will be passed to `Backpex.ResourceAction.changeset/3` in order to generate a changeset.\n\nThis function is optional and can be used to use changesets with schemas in resource actions. If this function\nis not provided a changeset will be generated automatically based on the provided types in `Backpex.ResourceAction.fields/0`.","ref":"Backpex.ResourceAction.html#c:init_change/1"},{"type":"callback","title":"Backpex.ResourceAction.label/0","doc":"The label of the resource action. It will be the label for the resource action button.","ref":"Backpex.ResourceAction.html#c:label/0"},{"type":"function","title":"Backpex.ResourceAction.name/2","doc":"Gets the name of a resource action.","ref":"Backpex.ResourceAction.html#name/2"},{"type":"callback","title":"Backpex.ResourceAction.title/0","doc":"The title of the resource action. It will be part of the page header and slide over title.","ref":"Backpex.ResourceAction.html#c:title/0"},{"type":"module","title":"Backpex.Router","doc":"Provides LiveView routing for Backpex resources.","ref":"Backpex.Router.html"},{"type":"function","title":"Backpex.Router.active?/2","doc":"Checks whether the to path is the same as the current path","ref":"Backpex.Router.html#active?/2"},{"type":"function","title":"Examples - Backpex.Router.active?/2","doc":"iex> Backpex.Router.active?(URI.new!(\"https://example.com/admin/events\"), \"/admin/events\")\n    true\n    iex> Backpex.Router.active?(URI.new!(\"https://example.com/admin/events\"), \"/admin/users\")\n    false","ref":"Backpex.Router.html#active?/2-examples"},{"type":"macro","title":"Backpex.Router.backpex_routes/0","doc":"","ref":"Backpex.Router.html#backpex_routes/0"},{"type":"function","title":"Backpex.Router.filter_actions/3","doc":"Filters `actions` based on `only` and `except` parameters.","ref":"Backpex.Router.html#filter_actions/3"},{"type":"function","title":"Examples - Backpex.Router.filter_actions/3","doc":"iex> Backpex.Router.filter_actions([:index, :edit, :show], [:index], nil)\n    [:index]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], nil, [:index])\n    [:edit, :show]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], nil, nil)\n    [:index, :edit, :show]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], [], [])\n    [:index, :edit, :show]","ref":"Backpex.Router.html#filter_actions/3-examples"},{"type":"function","title":"Backpex.Router.get_path/5","doc":"Finds the raw path by the given socket and module and puts the path params into the raw path.","ref":"Backpex.Router.html#get_path/5"},{"type":"function","title":"Backpex.Router.get_path/6","doc":"","ref":"Backpex.Router.html#get_path/6"},{"type":"function","title":"Backpex.Router.has_resource_actions?/2","doc":"","ref":"Backpex.Router.html#has_resource_actions?/2"},{"type":"macro","title":"Backpex.Router.live_resources/3","doc":"Defines \"RESTful\" routes for a Backpex resource.","ref":"Backpex.Router.html#live_resources/3"},{"type":"macro","title":"Options - Backpex.Router.live_resources/3","doc":"* `:only` - List of actions to generate routes for, for example: `[:index, :show]`.\n  * `:except` - List of actions to exclude generated routes from, for example: `[:edit]`.","ref":"Backpex.Router.html#live_resources/3-options"},{"type":"macro","title":"Example - Backpex.Router.live_resources/3","doc":"defmodule MyAppWeb.Router\n      import Backpex.Router\n\n      scope \"/admin\", MyAppWeb do\n        pipe_through :browser\n\n        live_session :default, on_mount: Backpex.InitAssigns do\n          live_resources(\"/users\", UserLive, only: [:index])\n        end\n      end\n    end","ref":"Backpex.Router.html#live_resources/3-example"},{"type":"function","title":"Backpex.Router.member?/3","doc":"Checks whether `item` is member of `list` and returns `default` value if list is `nil` or empty.","ref":"Backpex.Router.html#member?/3"},{"type":"function","title":"Examples - Backpex.Router.member?/3","doc":"iex> Backpex.Router.member?([:index], :index, true)\n    true\n    iex> Backpex.Router.member?([:edit], :index, true)\n    false\n    iex> Backpex.Router.member?([], :index, true)\n    true\n    iex> Backpex.Router.member?(nil, :index, true)\n    true","ref":"Backpex.Router.html#member?/3-examples"},{"type":"function","title":"Backpex.Router.put_route_params/2","doc":"Replace path params with actual params","ref":"Backpex.Router.html#put_route_params/2"},{"type":"function","title":"Examples - Backpex.Router.put_route_params/2","doc":"iex> Backpex.Router.put_route_params(\"/:param1/events/:param2/show\", %{\"param1\" => \"123\", \"param2\" => \"xyz\", \"test\" => \"abcdef\"})\n    \"/123/events/xyz/show\"\n    iex> Backpex.Router.put_route_params(\"/:param1/events/:id/edit\", %{\"param1\" => \"123\", \"id\" => \"xyz\"})\n    \"/123/events/xyz/edit\"\n    iex> Backpex.Router.put_route_params(\"/events\", %{\"param1\" => \"123\", \"param2\" => \"xyz\"})\n    \"/events\"\n    iex> Backpex.Router.put_route_params(\"/events\", %{})\n    \"/events\"","ref":"Backpex.Router.html#put_route_params/2-examples"},{"type":"module","title":"BackpexWeb","doc":"The entrypoint for defining the web interface of Backpex.","ref":"BackpexWeb.html"},{"type":"module","title":"Example - BackpexWeb","doc":"use BackpexWeb, :html","ref":"BackpexWeb.html#module-example"},{"type":"macro","title":"BackpexWeb.__using__/1","doc":"When used, dispatch to the appropriate function.","ref":"BackpexWeb.html#__using__/1"},{"type":"function","title":"BackpexWeb.field/0","doc":"Includes all globally available field functions and helpers.","ref":"BackpexWeb.html#field/0"},{"type":"function","title":"BackpexWeb.filter/0","doc":"","ref":"BackpexWeb.html#filter/0"},{"type":"function","title":"BackpexWeb.html/0","doc":"Includes all globally available HTML functions and helpers.","ref":"BackpexWeb.html#html/0"},{"type":"function","title":"BackpexWeb.item_action/0","doc":"Includes all globally available item action functions and helpers.","ref":"BackpexWeb.html#item_action/0"},{"type":"function","title":"BackpexWeb.metric/0","doc":"","ref":"BackpexWeb.html#metric/0"},{"type":"module","title":"Backpex.HTML","doc":"Contains common HTML functions.","ref":"Backpex.HTML.html"},{"type":"function","title":"Backpex.HTML.pretty_value/1","doc":"Prettifies any input and show a placeholder in case the value is `nil`.","ref":"Backpex.HTML.html#pretty_value/1"},{"type":"function","title":"Examples - Backpex.HTML.pretty_value/1","doc":"iex> Backpex.HTML.pretty_value(nil)\n    \"—\"\n\n    iex> Backpex.HTML.pretty_value(\"\")\n    \"—\"\n\n    iex> Backpex.HTML.pretty_value(1_000_000)\n    \"1.000.000\"\n\n    iex> Backpex.HTML.pretty_value(1.11)\n    1.11\n\n    iex> Backpex.HTML.pretty_value(\"Hello, universe\")\n    \"Hello, universe\"","ref":"Backpex.HTML.html#pretty_value/1-examples"},{"type":"module","title":"Backpex.HTML.Form","doc":"Contains all Backpex form components.","ref":"Backpex.HTML.Form.html"},{"type":"function","title":"Backpex.HTML.Form.error/1","doc":"Generates a generic error message.","ref":"Backpex.HTML.Form.html#error/1"},{"type":"function","title":"Slots - Backpex.HTML.Form.error/1","doc":"* `inner_block` (required)","ref":"Backpex.HTML.Form.html#error/1-slots"},{"type":"function","title":"Backpex.HTML.Form.field_input/1","doc":"Renders an input.","ref":"Backpex.HTML.Form.html#field_input/1"},{"type":"function","title":"Attributes - Backpex.HTML.Form.field_input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* `class` (`:string`) - additional class. Defaults to `nil`.\n* `input_class` (`:string`) - additional class for the input element. Defaults to `nil`.\n* `input_wrapper_class` (`:string`) - additional class for the input wrapper element, currently only used in select type. Defaults to `nil`.\n* `field_options` (`:map`) - field options map. Defaults to `%{}`.\n* `hide_errors` (`:boolean`) - if errors should be hidden. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"Backpex.HTML.Form.html#field_input/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Form.field_input/1","doc":"* `inner_block`","ref":"Backpex.HTML.Form.html#field_input/1-slots"},{"type":"function","title":"Backpex.HTML.Form.form_errors?/2","doc":"","ref":"Backpex.HTML.Form.html#form_errors?/2"},{"type":"function","title":"Backpex.HTML.Form.multi_select/1","doc":"Renders a searchable multi select.","ref":"Backpex.HTML.Form.html#multi_select/1"},{"type":"function","title":"Attributes - Backpex.HTML.Form.multi_select/1","doc":"* `prompt` (`:string`) (required) - string that will be shown when no option is selected.\n* `not_found_text` (`:string`) (required) - string that will be shown when there are no options.\n* `options` (`:list`) (required) - a list of options for the select.\n* `search_input` (`:string`) (required) - to prefill and or persist the search term for rerendering.\n* `event_target` (`:any`) (required) - the target that handles the events of this component.\n* `field_options` (`:map`) (required) - field options for the corresponding field.\n* `field` (`:any`) (required) - form field the select should be for.\n* `selected` (`:list`) (required) - the selected values.\n* `show_select_all` (`:boolean`) (required) - whether to display the select all button.\n* `show_more` (`:boolean`) (required) - whether there are more options to show.\n* `search_event` (`:string`) - the event that will be sent when the search input changes. Defaults to `\"search\"`.","ref":"Backpex.HTML.Form.html#multi_select/1-attributes"},{"type":"module","title":"Backpex.HTML.Layout","doc":"Contains all Backpex layout components.","ref":"Backpex.HTML.Layout.html"},{"type":"function","title":"Backpex.HTML.Layout.app_shell/1","doc":"Renders an app shell representing the base of your layout.","ref":"Backpex.HTML.Layout.html#app_shell/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.app_shell/1","doc":"* `fluid` (`:boolean`) - toggles fluid layout. Defaults to `false`.","ref":"Backpex.HTML.Layout.html#app_shell/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.app_shell/1","doc":"* `inner_block`\n* `topbar` - content to be displayed in the topbar. Accepts attributes:\n\n  * `class` (`:string`) - additional class that will be added to the component.\n* `sidebar` - content to be displayed in the sidebar. Accepts attributes:\n\n  * `class` (`:string`) - additional class that will be added to the component.\n* `footer` - content to be displayed in the footer.","ref":"Backpex.HTML.Layout.html#app_shell/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.backpex_logo/1","doc":"Get the Backpex logo SVG.","ref":"Backpex.HTML.Layout.html#backpex_logo/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.backpex_logo/1","doc":"* `class` (`:string`) - class that will be added to the SVG element. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#backpex_logo/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.field_container/1","doc":"Renders the form label and input with corresponding margin and alignment.","ref":"Backpex.HTML.Layout.html#field_container/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.field_container/1","doc":"* `class` (`:string`) - extra classes to be added. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#field_container/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.field_container/1","doc":"* `label` (required) - Accepts attributes:\n\n  * `align` (`:atom`) - Must be one of `:top`, `:center`, or `:bottom`.\n* `inner_block`","ref":"Backpex.HTML.Layout.html#field_container/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.flash_messages/1","doc":"Renders flash messages.","ref":"Backpex.HTML.Layout.html#flash_messages/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.flash_messages/1","doc":"* `flash` (`:map`) (required) - flash map that will be passed to `Phoenix.LiveView.Helpers.live_flash/2`.","ref":"Backpex.HTML.Layout.html#flash_messages/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.footer/1","doc":"Renders a footer. It provides a default look when no content is provided.","ref":"Backpex.HTML.Layout.html#footer/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.footer/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#footer/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.footer/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#footer/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.hide_modal/2","doc":"","ref":"Backpex.HTML.Layout.html#hide_modal/2"},{"type":"function","title":"Backpex.HTML.Layout.input_label/1","doc":"","ref":"Backpex.HTML.Layout.html#input_label/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.input_label/1","doc":"* `text` (`:string`) - text of the label.","ref":"Backpex.HTML.Layout.html#input_label/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.main_container/1","doc":"Container to wrap main elements and add margin.","ref":"Backpex.HTML.Layout.html#main_container/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.main_container/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#main_container/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.main_container/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#main_container/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.main_title/1","doc":"Renders a title.","ref":"Backpex.HTML.Layout.html#main_title/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.main_title/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#main_title/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.main_title/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#main_title/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.modal/1","doc":"","ref":"Backpex.HTML.Layout.html#modal/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.modal/1","doc":"* `title` (`:string`) - modal title. Defaults to `nil`.\n* `target` (`:string`) - live component for the close event to go to. Defaults to `nil`.\n* `close_event_name` (`:string`) - close event name. Defaults to `\"close-modal\"`.\n* `max_width` (`:string`) - modal max width. Defaults to `\"md\"`.\n* `open` (`:boolean`) - modal open. Defaults to `true`.\n* Global attributes are accepted.","ref":"Backpex.HTML.Layout.html#modal/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.modal/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#modal/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.sidebar_item/1","doc":"Renders a sidebar item. It uses `Phoenix.Component.link/1` component, so you can can use link and href navigation.","ref":"Backpex.HTML.Layout.html#sidebar_item/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.sidebar_item/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `current_url` (`:string`) - the current url.\n* `navigate` (`:string`)\n* `patch` (`:string`)\n* `href` (`:any`)","ref":"Backpex.HTML.Layout.html#sidebar_item/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.sidebar_item/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#sidebar_item/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.sidebar_section/1","doc":"Renders a sidebar section.","ref":"Backpex.HTML.Layout.html#sidebar_section/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.sidebar_section/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `id` (`:string`) - The id for this section. It will be used to save and load the opening state of this section from local storage. Defaults to `\"section\"`.","ref":"Backpex.HTML.Layout.html#sidebar_section/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.sidebar_section/1","doc":"* `inner_block`\n* `label` (required) - label to be displayed on the section.","ref":"Backpex.HTML.Layout.html#sidebar_section/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.topbar/1","doc":"Renders a topbar.","ref":"Backpex.HTML.Layout.html#topbar/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar/1","doc":"* `class` (`:string`) - additional class to be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#topbar/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#topbar/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.topbar_branding/1","doc":"Renders the topbar branding.","ref":"Backpex.HTML.Layout.html#topbar_branding/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar_branding/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `title` (`:string`) - title that will be displayed next to the logo. Defaults to `\"Backpex\"`.\n* `hide_title` (`:boolean`) - if the title should be hidden. Defaults to `false`.","ref":"Backpex.HTML.Layout.html#topbar_branding/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar_branding/1","doc":"* `logo` - the logo of the branding.","ref":"Backpex.HTML.Layout.html#topbar_branding/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.topbar_dropdown/1","doc":"Renders a topbar dropdown.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar_dropdown/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar_dropdown/1","doc":"* `label` (required) - label of the dropdown.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.visible_fields_by_panel/3","doc":"Filters fields by certain panel.","ref":"Backpex.HTML.Layout.html#visible_fields_by_panel/3"},{"type":"function","title":"Examples - Backpex.HTML.Layout.visible_fields_by_panel/3","doc":"iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default}, field2: %{panel: :panel}], :default, nil)\n    [field1: %{panel: :default}]\n\n    iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default, visible: fn _assigns -> false end}, field2: %{panel: :panel}], :default, nil)\n    []\n\n    iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default}], :panel, nil)\n    []","ref":"Backpex.HTML.Layout.html#visible_fields_by_panel/3-examples"},{"type":"module","title":"Backpex.HTML.Resource","doc":"Contains all Backpex resource components.","ref":"Backpex.HTML.Resource.html"},{"type":"function","title":"Backpex.HTML.Resource.edit_panel/1","doc":"Renders an edit panel.","ref":"Backpex.HTML.Resource.html#edit_panel/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.edit_panel/1","doc":"* `form` (`:any`)\n* `class` (`:string`) - extra class to be added. Defaults to `\"\"`.\n* `panel_fields` (`:list`) (required) - list of fields to be rendered in the panel.\n* `label` (`:any`) - optional label for the panel. Defaults to `nil`.","ref":"Backpex.HTML.Resource.html#edit_panel/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.empty_state/1","doc":"Renders an info block to indicate that no items are found.","ref":"Backpex.HTML.Resource.html#empty_state/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.empty_state/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:atom`) (required) - live resource module.\n* `params` (`:map`) (required) - query params.\n* `singular_name` (`:string`) (required) - singular name of the resource.","ref":"Backpex.HTML.Resource.html#empty_state/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.form_component/1","doc":"","ref":"Backpex.HTML.Resource.html#form_component/1"},{"type":"function","title":"Backpex.HTML.Resource.has_modal?/1","doc":"Checks the given module if it has a `confirm/1` function exported or a list with fields.","ref":"Backpex.HTML.Resource.html#has_modal?/1"},{"type":"function","title":"Backpex.HTML.Resource.index_filter/1","doc":"Renders the index filters if the `filter/0` callback is defined in the resource.","ref":"Backpex.HTML.Resource.html#index_filter/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.index_filter/1","doc":"* `live_resource` (`:any`) (required) - module of the live resource.\n* `filter_options` (`:map`) (required) - filter options.\n* `filters` (`:list`) (required) - list of active filters.","ref":"Backpex.HTML.Resource.html#index_filter/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.index_search_form/1","doc":"Renders form with a search field. Emits the `simple-search-input` event on change.","ref":"Backpex.HTML.Resource.html#index_search_form/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.index_search_form/1","doc":"* `searchable_fields` (`:list`) - The fields that can be searched. Here only used to hide the component when empty. Defaults to `[]`.\n* `full_text_search` (`:string`) - full text search column name. Defaults to `nil`.\n* `value` (`:string`) (required) - value binding for the search input.\n* `placeholder` (`:string`) (required) - placeholder for the search input.","ref":"Backpex.HTML.Resource.html#index_search_form/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.order_link/1","doc":"Renders a link to change the order direction for a given column.","ref":"Backpex.HTML.Resource.html#order_link/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.order_link/1","doc":"* `socket` (`:map`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) (required) - query options.\n* `label` (`:string`) (required) - label to be displayed on the link.\n* `name` (`:atom`) (required) - name of the column the link should change order for.","ref":"Backpex.HTML.Resource.html#order_link/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination/1","doc":"Renders pagination buttons. You are required to provide a `:page` pattern in the URL. It will be replaced\nwith the corresponding page number.","ref":"Backpex.HTML.Resource.html#pagination/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.pagination/1","doc":"* `current_page` (`:integer`) (required) - current page number.\n* `total_pages` (`:integer`) (required) - number of total pages.\n* `path` (`:string`) (required) - path to be used for page links.","ref":"Backpex.HTML.Resource.html#pagination/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination_info/1","doc":"Renders pagination info about the current page.","ref":"Backpex.HTML.Resource.html#pagination_info/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.pagination_info/1","doc":"* `total` (`:integer`) (required) - total number of items.\n* `query_options` (`:map`) (required) - query options.","ref":"Backpex.HTML.Resource.html#pagination_info/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination_items/2","doc":"Creates a list of pagination items based on the current page and the total number of pages. A maximum of five pages will be displayed.","ref":"Backpex.HTML.Resource.html#pagination_items/2"},{"type":"function","title":"Example - Backpex.HTML.Resource.pagination_items/2","doc":"iex> Backpex.HTML.Resource.pagination_items(1, 1)\n    [%{type: :number, number: 1}]\n\n    iex> Backpex.HTML.Resource.pagination_items(1, 2)\n    [%{type: :number, number: 1}, %{type: :number, number: 2}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(2, 2)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :number, number: 2}]\n\n    iex> Backpex.HTML.Resource.pagination_items(2, 8)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :number, number: 2}, %{type: :number, number: 3}, %{type: :number, number: 4}, %{type: :placeholder, number: nil}, %{type: :number, number: 8}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(5, 10)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :placeholder, number: nil}, %{type: :number, number: 4}, %{type: :number, number: 5}, %{type: :number, number: 6}, %{type: :placeholder, number: nil}, %{type: :number, number: 10}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(9, 10)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :placeholder, number: nil}, %{type: :number, number: 7}, %{type: :number, number: 8}, %{type: :number, number: 9}, %{type: :number, number: 10}, %{type: :next, number: nil}]","ref":"Backpex.HTML.Resource.html#pagination_items/2-example"},{"type":"function","title":"Backpex.HTML.Resource.resource_buttons/1","doc":"Renders a button group with create and resource action buttons.","ref":"Backpex.HTML.Resource.html#resource_buttons/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_buttons/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `resource_actions` (`:list`) - list of all resource actions provided by the resource configuration. Defaults to `[]`.\n* `singular_name` (`:string`) (required) - singular name of the resource.","ref":"Backpex.HTML.Resource.html#resource_buttons/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_field/1","doc":"Renders the field of the given resource.","ref":"Backpex.HTML.Resource.html#resource_field/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_field/1","doc":"* `name` (`:string`) (required) - name / key of the item field.\n* `item` (`:map`) (required) - the item which provides the value to be rendered.\n* `fields` (`:list`) (required) - list of all fields provided by the resource configuration.","ref":"Backpex.HTML.Resource.html#resource_field/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_filters/1","doc":"Renders the input fields for filters and search.","ref":"Backpex.HTML.Resource.html#resource_filters/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_filters/1","doc":"* `live_resource` (`:any`) (required) - module of the live resource.\n* `searchable_fields` (`:list`) - The fields that can be searched. Here only used to hide the component when empty. Defaults to `[]`.\n* `full_text_search` (`:string`) - full text search column name. Defaults to `nil`.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `search_placeholder` (`:string`) (required) - placeholder for the search input.","ref":"Backpex.HTML.Resource.html#resource_filters/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_form/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_form/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_form_field/1","doc":"Renders a resource form field.","ref":"Backpex.HTML.Resource.html#resource_form_field/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_form_field/1","doc":"* `name` (`:string`) (required) - name / key of the item field.\n* `form` (`:map`) (required) - form that will be used by the form field.\n* `repo` (`:any`) - ecto repo.\n* `uploads` (`:map`) - map that contains upload information. Defaults to `%{}`.\n* `fields` (`:list`) (required) - list of all fields provided by the resource configuration.","ref":"Backpex.HTML.Resource.html#resource_form_field/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_form_main/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_form_main/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_index/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_index/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_index_main/1","doc":"Renders the main resource index content.","ref":"Backpex.HTML.Resource.html#resource_index_main/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_index_main/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `total_pages` (`:integer`) - amount of total pages. Defaults to `1`.\n* `resource_actions` (`:list`) - list of all resource actions provided by the resource configuration. Defaults to `[]`.\n* `singular_name` (`:string`) (required) - singular name of the resource.\n* `orderable_fields` (`:list`) - list of orderable fields. Defaults to `[]`.\n* `items` (`:list`) - items that will be displayed in the table. Defaults to `[]`.\n* `fields` (`:list`) - list of fields to be displayed in the table on index view. Defaults to `[]`.","ref":"Backpex.HTML.Resource.html#resource_index_main/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_index_table/1","doc":"Renders a resource table.","ref":"Backpex.HTML.Resource.html#resource_index_table/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_index_table/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `fields` (`:list`) (required) - list of fields to be displayed in the table on index view.\n* `orderable_fields` (`:list`) - list of orderable fields. Defaults to `[]`.\n* `searchable_fields` (`:list`) - list of searchable fields. Defaults to `[]`.\n* `items` (`:list`) - items that will be displayed in the table. Defaults to `[]`.\n* `active_fields` (`:list`) (required) - list of active fields.\n* `selected_items` (`:list`) (required) - list of selected items.","ref":"Backpex.HTML.Resource.html#resource_index_table/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_metrics/1","doc":"Renders the metrics area for the current resource.","ref":"Backpex.HTML.Resource.html#resource_metrics/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_metrics/1","doc":"* `metrics` (`:list`) - list of metrics to be displayed. Defaults to `[]`.","ref":"Backpex.HTML.Resource.html#resource_metrics/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_show/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_show/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_show_main/1","doc":"Renders a show card.","ref":"Backpex.HTML.Resource.html#resource_show_main/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_show_main/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `item` (`:map`) (required) - item that will be rendered on the card.\n* `fields` (`:list`) (required) - list of fields to be displayed on the card.","ref":"Backpex.HTML.Resource.html#resource_show_main/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.select_per_page/1","doc":"Renders a select per page button.","ref":"Backpex.HTML.Resource.html#select_per_page/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.select_per_page/1","doc":"* `options` (`:list`) (required) - A list of per page options.\n* `query_options` (`:map`) - The query options. Defaults to `%{}`.\n* `class` (`:string`) - Extra class to be added to the select. Defaults to `\"\"`.","ref":"Backpex.HTML.Resource.html#select_per_page/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.show_panel/1","doc":"Renders a show panel.","ref":"Backpex.HTML.Resource.html#show_panel/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.show_panel/1","doc":"* `panel_fields` (`:list`) (required) - list of fields to be rendered in the panel.\n* `class` (`:string`) - extra class to be added. Defaults to `\"\"`.\n* `label` (`:any`) - optional label for the panel. Defaults to `nil`.","ref":"Backpex.HTML.Resource.html#show_panel/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.toggle_columns/1","doc":"","ref":"Backpex.HTML.Resource.html#toggle_columns/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.toggle_columns/1","doc":"* `socket` (`:any`) (required)\n* `active_fields` (`:list`) (required) - list of active fields.\n* `live_resource` (`:atom`) (required) - the live resource.\n* `current_url` (`:string`) (required) - the current url.\n* `class` (`:string`) - additional class to be added to the component. Defaults to `\"\"`.\n* `x_style` (`:string`) - alpine-bound inline styles for the root div. Defaults to `\"\"`.","ref":"Backpex.HTML.Resource.html#toggle_columns/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.toggle_columns_inputs/1","doc":"","ref":"Backpex.HTML.Resource.html#toggle_columns_inputs/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.toggle_columns_inputs/1","doc":"* `form` (`:any`) (required) - the form.\n* `active_fields` (`:list`) (required) - list of active fields to be displayed.","ref":"Backpex.HTML.Resource.html#toggle_columns_inputs/1-attributes"},{"type":"behaviour","title":"Backpex.Field","doc":"Behaviour implemented by all fields.\n\nA field defines how a column is rendered on index, show and edit views. In the resource configuration file you can configure\na list of fields. You may create your own field by implementing this behaviour. A field has to be a [LiveComponent](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveComponent.html).\n\nWhen creating your own field, you can use the `field` macro from the `BackpexWeb` module. It automatically implements the `Backpex.Field` behaviour\nand defines some aliases and imports.\n\nThe simplest version of a custom field would look like this:\n\n    use BackpexWeb, :field\n\n    @impl Backpex.Field\n    def render_value(assigns) do\n      ~H\"\"\"\n       \n        <%= HTML.pretty_value(@value) %>\n       \n      \"\"\"\n    end\n\n    @impl Backpex.Field\n    def render_form(assigns) do\n      ~H\"\"\"\n       \n         \n          <:label>\n             \n          </:label>\n           \n         \n       \n      \"\"\"\n    end\n\nThe `render_value/1` function returns markup that is used to display a value on `index` and `show` views.\nThe `render_form/1` function returns markup that is used to render a form on `edit` and `new` views.\n\nThe list of fields in the resource configuration has to be a keyword list. The key has to be the name of the column.\nThe value has to be a list of options represented as a map. At least you are required to provide the module of the field and a label as options.\nFor extra information and options you may have to look into the corresponding field documentation.","ref":"Backpex.Field.html"},{"type":"behaviour","title":"Example - Backpex.Field","doc":"def fields do\n      [\n        rating: %{\n          module: Backpex.Fields.Text,\n          label: \"Rating\"\n        }\n      ]\n    end","ref":"Backpex.Field.html#module-example"},{"type":"behaviour","title":"Read-only fields - Backpex.Field","doc":"Fields can be configured to be read-only. In edit view, these fields are rendered with the additional HTML attributes `readonly` and `disabled`,\nensuring that the user cannot interact with the field or change its value.\n\nIn index view, if read-only and index editable are set to `true`, forms will be rendered with the `readonly` HTML attribute.\n\nCurrently read-only configuration is possible for `Backpex.Fields.Text` and `Backpex.Fields.Textarea` on edit view.\n\nOn the index view, read-only is supported for all fields with the index editable option.\n\nYou can also add read-only functionality to a custom field. To do this, you need to define a `render_form_readonly/1` function.\nThis function must return markup to be used when read-only is enabled.\n\n    @impl Backpex.Field\n    def render_form_readonly(assigns) do\n      ~H\"\"\"\n       \n         \n          <:label>\n             \n          </:label>\n           \n         \n       \n      \"\"\"\n    end\n\nWhen defining a custom field with index editable support, you need to handle the read-only state in the index editable markup.\nWe pass a `readonly` value to index fields, which will be `true` or `false` depending on the read-only option of the field and the `can?/3` function.\n\nFields can be set to read-only in the configuration map of the field by adding the `readonly` option. This key must\ncontain either a boolean value or a function that returns a boolean value.\n\nThe function takes `assigns` as a parameter. This allows the field to be set as read-only programmatically, as the\nfollowing example illustrates:\n\n    rating: %{\n      module: Backpex.Fields.Text,\n      label: \"Rating\",\n      readonly: fn assigns ->\n        assigns.current_user.role in [:employee]\n      end\n    }","ref":"Backpex.Field.html#module-read-only-fields"},{"type":"behaviour","title":"Custom Alias Configuration - Backpex.Field","doc":"Backpex automatically generates aliases for queries in your fields. However, if you try to add two `BelongsTo` fields of the same association, you will encounter an error indicating that the alias is already in use by another field. To resolve this issue, Backpex allows the assignment of custom aliases to fields, eliminating naming conflicts in queries.\n\nTo use a custom alias, especially with a `:select` query, define it within your field configuration. This allows you to reference associated data via the custom alias.\n\nExample usage of a custom alias together with a `:select`:\n\n    second_category: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Second Category\",\n      display_field: :name,\n      searchable: true,\n      custom_alias: :second_category,\n      select: dynamic([second_category: sc], sc.name)\n    },","ref":"Backpex.Field.html#module-custom-alias-configuration"},{"type":"behaviour","title":"Computed Fields - Backpex.Field","doc":"Sometimes you want to compute new fields based on existing fields.\n\nImagine there is a user table with `first_name` and `last_name`. Now, on your index view you want to add a column to display\nthe `full_name`. You could create a generated column in you database, but there are several reasons for not adding generated\ncolumns for all computed fields you want to display in your application.\n\nBackpex adds a way to support this.\n\nThere is a `select` option you may add to a field. This option has to return a `dynamic`. This query will then be executed to\nselect fields when listing your resources. In addition this query will also be used to order / search this field.\n\nTherefore you can display the `full_name` of your users by adding the following field to the resource configuration file.\n\n    full_name: %{\n      module: Backpex.Fields.Text,\n      label: \"Full Name\",\n      searchable: true,\n      except: [:edit],\n      select: dynamic([user: u], fragment(\"concat(?, ' ', ?)\", u.first_name, u.last_name))\n    }\n\nWe are using a database fragment to build the `full_name` based on the `first_name` and `last_name` of an user. Backpex will select this field when listing resources automatically.\nOrdering and searching works the same like on all other fields, because Backpex uses the query you provided in the `dynamic` in order / search queries, too.\n\nWe recommend to display this field on `index` and `show` view only.\n\n> Note: You are required to add a virtual field `full_name` to your user schema. Otherwise, Backpex is not able to select this field.\n\nComputed fields also work in associations.\n\nFor example, you are able to add a `select` query to a `BelongsTo` field.\n\nImagine you want to display a list of posts with the corresponding authors (users). The user column should be a `full_name` computed by the `first_name` and `last_name`:\n\n    user: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Full Name\",\n      display_field: :full_name,\n      select: dynamic([user: u], fragment(\"concat(?, ' ', ?)\", u.first_name, u.last_name)),\n      options_query: fn query, _assigns ->\n        query |> select_merge([user], %{full_name: fragment(\"concat(?, ' ', ?)\", user.first_name, user.last_name)})\n      end\n    }\n\nWe recommend to add a `select_merge` to the `options_query` where you select the same field. Otherwise, displaying the same values in the select form on edit page will not work.\n\nDo not forget to add the virtual field `full_name` to your user schema in this example, too.","ref":"Backpex.Field.html#module-computed-fields"},{"type":"behaviour","title":"Error Customisation - Backpex.Field","doc":"Each field can define a `translate_error/1` function to use custom error messages. The function is called for each error and must return a tuple with a message and metadata.\n\nFor example, if you want to indicate that an integer input must be a number:\n\n    number: %{\n      module: Backpex.Fields.Number,\n      label: \"Number\",\n      translate_error: fn\n        {_msg, [type: :integer, validation: :cast] = metadata} = _error ->\n          {\"has to be a number\", metadata}\n\n        error ->\n          error\n      end\n    }","ref":"Backpex.Field.html#module-error-customisation"},{"type":"macro","title":"Backpex.Field.__using__/1","doc":"Defines `Backpex.Field` behaviour and provides default implementations.","ref":"Backpex.Field.html#__using__/1"},{"type":"function","title":"Backpex.Field.align_label/3","doc":"Gets alignment option for label.","ref":"Backpex.Field.html#align_label/3"},{"type":"callback","title":"Backpex.Field.assign_uploads/2","doc":"This function will be called in the `FormComponent` and may be used to assign uploads.","ref":"Backpex.Field.html#c:assign_uploads/2"},{"type":"callback","title":"Backpex.Field.association?/1","doc":"Determines whether the field is an association or not.","ref":"Backpex.Field.html#c:association?/1"},{"type":"function","title":"Backpex.Field.changeset_types/1","doc":"Returns a map of types from a list of fields used for the Ecto changeset.","ref":"Backpex.Field.html#changeset_types/1"},{"type":"function","title":"Backpex.Field.debounce/2","doc":"Defines debounce timeout value.","ref":"Backpex.Field.html#debounce/2"},{"type":"callback","title":"Backpex.Field.display_field/1","doc":"The field to be displayed on index views. In most cases this is the name / key configured in the corresponding field definition.\nIn fields with associations this value often differs from the name / key. The function will receive the field definition.","ref":"Backpex.Field.html#c:display_field/1"},{"type":"function","title":"Backpex.Field.handle_index_editable/2","doc":"Handles index editable.","ref":"Backpex.Field.html#handle_index_editable/2"},{"type":"function","title":"Backpex.Field.index_editable_enabled?/3","doc":"Checks whether index editable is enabled or not.","ref":"Backpex.Field.html#index_editable_enabled?/3"},{"type":"function","title":"Backpex.Field.placeholder/2","doc":"Defines placeholder value.","ref":"Backpex.Field.html#placeholder/2"},{"type":"function","title":"Backpex.Field.readonly?/2","doc":"Determines whether the field should be rendered as readonly version.","ref":"Backpex.Field.html#readonly?/2"},{"type":"callback","title":"Backpex.Field.render_form/1","doc":"Will be used on edit views to render a form for the value of the provided item. This has to be a heex template.","ref":"Backpex.Field.html#c:render_form/1"},{"type":"callback","title":"Backpex.Field.render_form_readonly/1","doc":"Used to render the readonly version of the field.","ref":"Backpex.Field.html#c:render_form_readonly/1"},{"type":"callback","title":"Backpex.Field.render_index_form/1","doc":"Used to render form on index to support index editable.","ref":"Backpex.Field.html#c:render_index_form/1"},{"type":"callback","title":"Backpex.Field.render_value/1","doc":"Will be used on index and show views to render a value from the provided item. This has to be a heex template.","ref":"Backpex.Field.html#c:render_value/1"},{"type":"callback","title":"Backpex.Field.schema/2","doc":"The schema to be used in queries. In most cases this is the schema defined in the resource configuration.\nIn fields with associations this is the schema of the corresponding relation. The function will receive the field definition and the schema defined in the resource configuration.","ref":"Backpex.Field.html#c:schema/2"},{"type":"callback","title":"Backpex.Field.search_condition/3","doc":"Defines the search condition. Defaults to an ilike condition with text comparison. The function has to return a query wrapped into a `Ecto.Query.dynamic/2` which is then passed into a `Ecto.Query.where/3`.","ref":"Backpex.Field.html#c:search_condition/3"},{"type":"callback","title":"Example - Backpex.Field.search_condition/3","doc":"Imagine the underlying database type of the field is an integer. Before text comparison in an ilike condition you have to cast the integer to text.\n\nThe function could return the following query to make the field searchable.\n\n    dynamic(\n      [{^schema_name, schema_name}],\n      ilike(fragment(\"CAST(? AS TEXT)\", schema_name |> field(^field_name)), ^search_string)\n    )","ref":"Backpex.Field.html#c:search_condition/3-example"},{"type":"function","title":"Backpex.Field.throttle/2","doc":"Defines throttle timeout value.","ref":"Backpex.Field.html#throttle/2"},{"type":"module","title":"Backpex.Fields.BelongsTo","doc":"A field for handling a `belongs_to` relation.","ref":"Backpex.Fields.BelongsTo.html"},{"type":"module","title":"Options - Backpex.Fields.BelongsTo","doc":"* `:display_field` - The field of the relation to be used for searching, ordering and displaying values.\n  * `:display_field_form` - Optional field to be used to display form values.\n  * `:live_resource` - The live resource of the association. Used to generate links navigating to the association.\n  * `:options_query` - Manipulates the list of available options in the select.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.\n  * `:prompt` - The text to be displayed when no option is selected or function that receives the assigns.","ref":"Backpex.Fields.BelongsTo.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.BelongsTo","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      user: %{\n        module: Backpex.Fields.BelongsTo,\n        label: \"Username\",\n        display_field: :username,\n        options_query: &where(&1, [user], user.role == :admin),\n        live_resource: DemoWeb.UserLive\n      }\n    ]\n    end","ref":"Backpex.Fields.BelongsTo.html#module-example"},{"type":"module","title":"Backpex.Fields.Boolean","doc":"A field for handling a boolean value.","ref":"Backpex.Fields.Boolean.html"},{"type":"module","title":"Options - Backpex.Fields.Boolean","doc":"* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Boolean.html#module-options"},{"type":"module","title":"Backpex.Fields.Currency","doc":"A field for handling a currency value.","ref":"Backpex.Fields.Currency.html"},{"type":"module","title":"Options - Backpex.Fields.Currency","doc":"* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Currency.html#module-options"},{"type":"module","title":"Schema - Backpex.Fields.Currency","doc":"`Backpex.Ecto.Amount.Type` provides a type for Ecto to store a amount. The underlying data type should be an integer.\nFor a full list of configuration options see: https://hexdocs.pm/money/Money.html#module-configuration\n\n    schema \"article\" do\n      field :price, Backpex.Ecto.Amount.Type\n      ...\n    end\n\n    schema \"article\" do\n      field :price, Backpex.Ecto.Amount.Type, currency: :EUR, opts: [separator: \".\", delimiter: \",\"]\n      ...\n    end","ref":"Backpex.Fields.Currency.html#module-schema"},{"type":"module","title":"Example - Backpex.Fields.Currency","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        price: %{\n          module: Backpex.Fields.Currency,\n          label: \"Price\"\n        }\n      ]\n    end","ref":"Backpex.Fields.Currency.html#module-example"},{"type":"module","title":"Backpex.Fields.Date","doc":"A field for handling a date value.","ref":"Backpex.Fields.Date.html"},{"type":"module","title":"Options - Backpex.Fields.Date","doc":"* `:format` - Defines the date format printed on the index view.\n    Defaults to `%Y-%m-%d`.\n  * `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n  * `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Date.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.Date","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        created_at: %{\n          module: Backpex.Fields.Date,\n          label: \"Created At\",\n          format: \"%d.%m.%Y\"\n        }\n      ]\n    end","ref":"Backpex.Fields.Date.html#module-example"},{"type":"module","title":"Backpex.Fields.DateTime","doc":"A field for handling a date time value.","ref":"Backpex.Fields.DateTime.html"},{"type":"module","title":"Options - Backpex.Fields.DateTime","doc":"* `:format` - Format string which will be used to format the date time value.\n    Defaults to `%Y-%m-%d %I:%M %p`\n  * `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n  * `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.DateTime.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.DateTime","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        created_at: %{\n          module: Backpex.Fields.DateTime,\n          label: \"Created At\",\n          format: \"%Y.%m.%d %I:%M %p\" # optional\n        }\n      ]\n    end","ref":"Backpex.Fields.DateTime.html#module-example"},{"type":"module","title":"Backpex.Fields.HasMany","doc":"A field for handling a `has_many` relation.\n\nThis field can not be orderable or searchable.","ref":"Backpex.Fields.HasMany.html"},{"type":"module","title":"Options - Backpex.Fields.HasMany","doc":"* `:display_field` - The field of the relation to be used for searching, ordering and displaying values.\n  * `:display_field_form` - Optional field to be used to display form values.\n  * `:live_resource` - The live resource of the association. Used to generate links navigating to the associations.\n  * `:options_query` - Manipulates the list of available options in the multi select.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.\n  * `:prompt` - The text to be displayed when no options are selected or function that receives the assigns.\n    Defaults to \"Select options...\".\n  * `:not_found_text` - The text to be displayed when no options are found.\n    Defaults to \"No options found\".\n  * `:live_resource` - Optional live resource module used to generate links to the corresponding show view for the item.\n  * `:query_limit` - Optional limit passed to the query to fetch new items. Set to `nil` to have no limit.\n    Defaults to 10.","ref":"Backpex.Fields.HasMany.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.HasMany","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      posts: %{\n        module: Backpex.Fields.HasMany,\n        label: \"Posts\",\n        display_field: :title,\n        options_query: &where(&1, [user], user.role == :admin),\n        live_resource: DemoWeb.PostLive\n      }\n    ]\n    end","ref":"Backpex.Fields.HasMany.html#module-example"},{"type":"module","title":"Backpex.Fields.HasManyThrough","doc":"A field for handling a `has_many` (`through`) relation.\n\nThis field is not orderable or searchable.\n\n> #### Warning {: .warning}\n>\n> This field is in beta state. Use at your own risk.","ref":"Backpex.Fields.HasManyThrough.html"},{"type":"module","title":"Options - Backpex.Fields.HasManyThrough","doc":"* `:display_field` - The field of the relation to be used for displaying options in the select.\n  * `:live_resource` - The corresponding live resource of the association. Used to display the title of the modal and generate defaults for `:child_fields` fields.\n  * `:sort_by` - A list of columns by which the child element output will be sorted. The sorting takes place in ascending order.\n  * `:child_fields` - WIP\n  * `:pivot_fields` - List to map additional data of the pivot table to Backpex fields.\n  * `:options_query` - Manipulates the list of available options in the select. Can be used to select additional data for the `display_field` option or to limit the available entries.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.","ref":"Backpex.Fields.HasManyThrough.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.HasManyThrough","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      addresses: %{\n        module: Backpex.Fields.HasManyThrough,\n        label: \"Addresses\",\n        display_field: :street,\n        live_resource: DemoWeb.AddressLive,\n        sort_by: [:zip, :city],\n        pivot_fields: [\n          type: %{\n            module: Backpex.Fields.Select,\n            label: \"Address Type\",\n            options: [Shipping: \"shipping\", Billing: \"billing\"]\n          }\n        ]\n      }\n    ]\n    end\n\nThe field requires a [`Ecto.Schema.has_many/3`](https://hexdocs.pm/ecto/Ecto.Schema.html#has_many/3) relation with a mandatory `through` option in the main schema. Any extra column in the pivot table besides the relational id's must be mapped in the `pivot_fields` option or given a default value.","ref":"Backpex.Fields.HasManyThrough.html#module-example"},{"type":"module","title":"Backpex.Fields.InlineCRUD","doc":"A field to handle inline CRUD operations. It can be used with either an `embeds_many` or `has_many` (association) type column.","ref":"Backpex.Fields.InlineCRUD.html"},{"type":"module","title":"Options - Backpex.Fields.InlineCRUD","doc":"* `:type` - The type of the field. Either `:embed` or `:assoc`.\n* `:child_fields` - A list of input fields to be used. Currently only support `Backpex.Fields.Text` fields.\n\nYou can add additional classes to child field inputs by setting the class option in the list of `child_fields`.\nThe class can be a string or a function that takes the assigns and must return a string.\nIn addition, you can optionally specify the input type of child field inputs with the `input_type` option. We currently\nsupport `:text` and `:textarea`. The `input_type` defaults to `:text`.\n\n> #### Important {: .info}\n>\n> Everything is currently handled by plain text input.","ref":"Backpex.Fields.InlineCRUD.html#module-options"},{"type":"module","title":"EmbedsMany - Backpex.Fields.InlineCRUD","doc":"The field in the migration must be of type `:map`. You also need to use ecto's `cast_embed/2` in the changeset.","ref":"Backpex.Fields.InlineCRUD.html#module-embedsmany"},{"type":"module","title":"Example - Backpex.Fields.InlineCRUD","doc":"def changeset(your_schema, attrs) do\n      your_schema\n      ...\n      |> cast_embed(:your_field,\n        with: &your_field_changeset/2,\n        sort_param: :your_field_order,\n        drop_param: :your_field_delete\n      )\n      ...\n    end\n\n> #### Important {: .info}\n>\n> We use the Ecto `:sort_param` and `:drop_param` to keep track of order and dropped items. Therefore, you need to use these options as well in your changeset. The name has to be ` _order` and ` _delete`.","ref":"Backpex.Fields.InlineCRUD.html#module-example"},{"type":"module","title":"HasMany (Association) - Backpex.Fields.InlineCRUD","doc":"A HasMany relation does not require any special configuration. You can simply define a basic `Ecto.Schema.has_many/3` relation to be used with the Backpex.Fields.InlineCRUD field.\n\n> #### Important {: .info}\n>\n> You need to set `on_replace: :delete` to be able to delete items, and `on_delete: :delete_all` to be able to delete a resource with existing items. It is recommended that you also add `on_delete: :delete_all` to your migration.","ref":"Backpex.Fields.InlineCRUD.html#module-hasmany-association"},{"type":"module","title":"Example - Backpex.Fields.InlineCRUD","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        embeds_many: %{\n          module: Backpex.Fields.InlineCRUD,\n          label: \"EmbedsMany\",\n          type: :embed,\n          except: [:index],\n          child_fields: [\n            field1: %{\n              module: Backpex.Fields.Text,\n              label: \"Label1\"\n            },\n            field2: %{\n              module: Backpex.Fields.Text,\n              label: \"Label2\"\n            }\n          ]\n        }\n      ]\n    end","ref":"Backpex.Fields.InlineCRUD.html#module-example"},{"type":"module","title":"Backpex.Fields.ManyToMany","doc":"A field for handling a `many_to_many` relation.\n\nThis field can not be orderable or searchable.","ref":"Backpex.Fields.ManyToMany.html"},{"type":"module","title":"Options - Backpex.Fields.ManyToMany","doc":"* `:display_field` - The field of the relation to be used for searching, ordering and displaying values.\n  * `:display_field_form` - Optional field to be used to display form values.\n  * `:live_resource` - The live resource of the association. Used to generate links navigating to the associations.\n  * `:options_query` - Manipulates the list of available options in the multi select.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.\n  * `:prompt` - The text to be displayed when no options are selected or function that receives the assigns.\n    Defaults to \"Select options...\".\n  * `:not_found_text` - The text to be displayed when no options are found.\n    Defaults to \"No options found\".\n  * `:live_resource` - Optional live resource module used to generate links to the corresponding show view for the item.\n  * `:query_limit` - Optional limit passed to the query to fetch new items. Set to `nil` to have no limit.\n    Defaults to 10.","ref":"Backpex.Fields.ManyToMany.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.ManyToMany","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      posts: %{\n        module: Backpex.Fields.HasMany,\n        label: \"Posts\",\n        display_field: :title,\n        options_query: &where(&1, [user], user.role == :admin),\n        live_resource: DemoWeb.PostLive\n      }\n    ]\n    end","ref":"Backpex.Fields.ManyToMany.html#module-example"},{"type":"module","title":"Backpex.Fields.MultiSelect","doc":"A field for handling a multi select with predefined options.\n\nThis field can not be searchable.","ref":"Backpex.Fields.MultiSelect.html"},{"type":"module","title":"Options - Backpex.Fields.MultiSelect","doc":"* `:options` - Required (keyword) list of options to be used for the select.\n  * `:prompt` - The text to be displayed when no options are selected or function that receives the assigns.\n    Defaults to \"Select options...\".\n  * `:not_found_text` - The text to be displayed when no options are found.\n    Defaults to \"No options found\".","ref":"Backpex.Fields.MultiSelect.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.MultiSelect","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        users: %{\n          module: Backpex.Fields.MultiSelect,\n          label: \"Users\",\n          options: fn _assigns -> [{\"Alex\", \"user_id_alex\"}, {\"Bob\", \"user_id_bob\"}] end\n        },\n      ]","ref":"Backpex.Fields.MultiSelect.html#module-example"},{"type":"module","title":"Backpex.Fields.Number","doc":"A field for handling a number value.","ref":"Backpex.Fields.Number.html"},{"type":"module","title":"Options - Backpex.Fields.Number","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Number.html#module-options"},{"type":"module","title":"Backpex.Fields.Select","doc":"A field for handling a select value.","ref":"Backpex.Fields.Select.html"},{"type":"module","title":"Options - Backpex.Fields.Select","doc":"* `:options` - Required (keyword) list of options or function that receives the assigns.\n  * `:prompt` - The text to be displayed when no option is selected or function that receives the assigns.","ref":"Backpex.Fields.Select.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.Select","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        role: %{\n          module: Backpex.Fields.Select,\n          label: \"Role\",\n          options: [Admin: admin, User: user]\n        }\n      ]\n    end","ref":"Backpex.Fields.Select.html#module-example"},{"type":"module","title":"Backpex.Fields.Text","doc":"A field for handling a text value.","ref":"Backpex.Fields.Text.html"},{"type":"module","title":"Options - Backpex.Fields.Text","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Text.html#module-options"},{"type":"module","title":"Backpex.Fields.Textarea","doc":"A field for handling long text values.","ref":"Backpex.Fields.Textarea.html"},{"type":"module","title":"Options - Backpex.Fields.Textarea","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Textarea.html#module-options"},{"type":"module","title":"Backpex.Fields.URL","doc":"A field for handling an URL value.","ref":"Backpex.Fields.URL.html"},{"type":"module","title":"Options - Backpex.Fields.URL","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.URL.html#module-options"},{"type":"module","title":"Backpex.Fields.Upload","doc":"A field for handling an upload.\n\n> #### Warning {: .warning}\n>\n> This field is in beta state. Use at your own risk.","ref":"Backpex.Fields.Upload.html"},{"type":"module","title":"Options - Backpex.Fields.Upload","doc":"* `:upload_key` - Required identifier for the upload field.\n  * `:accept` - Required filetypes that will be accepted.\n  * `:max_entries` - Required number of max files that can be uploaded.\n  * `:max_file_size` - Optional maximum file size in bytes to be allowed to uploaded. Defaults 8 MB (`8_000_000`).\n  * `:list_files` - Required function that returns a list of all uploaded files.\n  * `:file_label` - Optional function to get the label of a single file.\n  * `:consume` - Required function to consume file uploads and handle changes in the item before it is saved (e.g. append file paths).\n  * `:remove` - Required function to remove a specific file.","ref":"Backpex.Fields.Upload.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.Upload","doc":"","ref":"Backpex.Fields.Upload.html#module-example"},{"type":"module","title":"Single File - Backpex.Fields.Upload","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      avatar: %{\n        module: Backpex.Fields.Upload,\n        label: \"Avatar\",\n        upload_key: :avatar,\n        accept: ~w(.jpg .jpeg),\n        max_entries: 1,\n        max_file_size: 12_000_000,\n        consume: &consume_avatar/3,\n        remove: &remove_avatar/2,\n        list_files: &list_files_avatar/1,\n        render: fn\n          %{value: \"\"} = assigns -> ~H\"<%= Backpex.HTML.pretty_value(@value) %>\"\n          assigns -> ~H' '\n        end\n      },\n    ]\n    end\n\n    defp avatar_static_dir, do: Path.join([\"uploads\", \"user\", \"avatar\"])\n\n    defp avatar_file_url(file_name) do\n      static_path = Path.join([avatar_static_dir(), file_name])\n      Phoenix.VerifiedRoutes.static_url(MyAppWeb.Endpoint, \"/\" <> static_path)\n    end\n\n    defp avatar_file_name(entry) do\n      [ext | _] = MIME.extensions(entry.client_type)\n      \"#{entry.uuid}.#{ext}\"\n    end\n\n    # will be called in order to display files when editing item\n    defp list_files_avatar(%{avatar: \"\"}), do: []\n    defp list_files_avatar(%{avatar: avatar}), do: [avatar]\n\n    # will be called to consume avatar\n    # you may add completed file upload paths as part of the change in order to persist them\n    # you have to return the (modified) change\n    defp consume_avatar(socket, _resource, %{} = change) do\n      consume_uploaded_entries(socket, :avatar, fn %{path: path}, entry ->\n        file_name = avatar_file_name(entry)\n        dest = Path.join([:code.priv_dir(:my_app), \"static\", avatar_static_dir(), file_name])\n        File.cp!(path, dest)\n        {:ok, avatar_file_url(file_name)}\n      end)\n\n      case uploaded_entries(socket, :avatar) do\n        {[] = _completed, []} -> change\n        {[entry | _] = _completed, []} -> Map.put(change, \"avatar\", avatar_file_name(entry))\n      end\n    end\n\n    def remove_avatar(resource, _target) do\n      Repo.get_by!(User, id: resource.id)\n      |> User.changeset(%{avatar: \"\"})\n      |> Repo.update!()\n\n      []\n    end","ref":"Backpex.Fields.Upload.html#module-single-file"},{"type":"module","title":"Multiple Files - Backpex.Fields.Upload","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      gallery: %{\n        module: Backpex.Fields.Upload,\n        label: \"Gallery\",\n        upload_key: :gallery,\n        accept: ~w(.jpg .jpeg),\n        max_entries: 5,\n        list_files: &list_files_gallery/2,\n        consume: &consume_gallery/3,\n        remove: &remove_gallery/3,\n      }\n    ]\n    end\n\n    defp gallery_static_dir, do: Path.join([\"uploads\", \"user\", \"gallery\"])\n\n    defp gallery_file_url(file_name) do\n      static_path = Path.join([gallery_static_dir(), file_name])\n      Phoenix.VerifiedRoutes.static_url(MyAppWeb.Endpoint, \"/\" <> static_path)\n    end\n\n    defp gallery_file_name(entry) do\n      [ext | _] = MIME.extensions(entry.client_type)\n      \"#{entry.uuid}.#{ext}\"\n    end\n\n    # will be called to consume uploads\n    # you may add completed file upload paths as part of the change in order to persist them\n    # you have to return the (modified) change\n    def consume_gallery(socket, item, %{} = change) do\n      consume_uploaded_entries(socket, :gallery, fn %{path: path}, entry ->\n        file_name = gallery_file_name(entry)\n        dest = Path.join([:code.priv_dir(:my_app), \"static\", gallery_static_dir(), file_name])\n        File.cp!(path, dest)\n        {:ok, gallery_file_url(file_name)}\n      end)\n\n      {completed, []} = uploaded_entries(socket, :gallery)\n\n      file_names = Enum.map(completed, fn entry -> gallery_file_name(entry) end)\n\n      file_names =\n        case item do\n          %{id: id} when is_binary(id) ->\n            (Repo.get_by!(Event, id: id) |> Map.get(:gallery)) ++ file_names\n\n          _ ->\n            file_names\n        end\n\n      Map.put(change, \"gallery\", file_names)\n    end\n\n    # will be called in order to display files when editing item\n    def list_files_gallery(%{gallery: gallery}), do: gallery\n\n    # will be called when deleting certain file from existing item\n    # target is the key you provided in list/2\n    # remove files from file system and item, return new file paths to be displayed\n    def remove_gallery(item, target) do\n      element = Repo.get_by!(Event, id: item.id)\n\n      file_paths =\n        Map.get(element, :gallery)\n        |> Enum.reject(&(&1 == target))\n\n      Event.changeset(element, %{gallery: file_paths})\n      |> Repo.update!()\n\n      file_paths\n    end","ref":"Backpex.Fields.Upload.html#module-multiple-files"},{"type":"function","title":"Backpex.Fields.Upload.label_from_file/2","doc":"Calls field option function to get label from filename. Defaults to filename.","ref":"Backpex.Fields.Upload.html#label_from_file/2"},{"type":"function","title":"Examples - Backpex.Fields.Upload.label_from_file/2","doc":"iex> Backpex.Fields.Upload.label_from_file(%{file_label: fn file -> file <> \"xyz\" end}, \"file\")\n    \"filexyz\"\n    iex> Backpex.Fields.Upload.label_from_file(%{}, \"file\")\n    \"file\"","ref":"Backpex.Fields.Upload.html#label_from_file/2-examples"},{"type":"function","title":"Backpex.Fields.Upload.map_file_paths/2","doc":"Maps uploaded files to keyword list with identifier and label.","ref":"Backpex.Fields.Upload.html#map_file_paths/2"},{"type":"function","title":"Examples - Backpex.Fields.Upload.map_file_paths/2","doc":"iex> Backpex.Fields.Upload.map_file_paths(%{list_files: fn item -> item.file_paths end}, %{file_paths: [\"xyz.png\"]})\n    [{\"xyz.png\", \"xyz.png\"}]","ref":"Backpex.Fields.Upload.html#map_file_paths/2-examples"},{"type":"behaviour","title":"Backpex.ItemAction","doc":"Behaviour implemented by all item actions.\n\nAn Item Action defines an action (such as deleting a user) that can be performed on one or more items.\nUnlike resource actions, item actions are not automatically performed on all items in a resource.\nFirst, items must be selected.\n\nThere are multiple ways to perform an Item Action:\n- use the checkboxes in the first column of the resource table to select 1-n items and trigger the action later on\n- use an icon in the last column of the resource table to perform the Item Action for one item\n- use the corresponding icon in the show view to perform the Item Action for the corresponding item\n\nIf you use the first method, you must trigger the item action using the button above the resource action. If you use the second or third method, the item action is triggered immediately.\n\nTherefore, you need to provide a label and an icon in your code. The label is displayed above the resource table and the icon\nis displayed for each element in the table and in the show view. This gives the user multiple ways to trigger your item action.\n\nOptionally, there can be a confirmation modal. You can enable this by specifying a text to be displayed in the modal via the `confirm` function. You can also specify a changeset and a list of fields. The fields are displayed in the confirm modal as well.\nFor example, a field could be a reason for deleting a user.\n\nIn the list of fields, each field needs a type. This is because we cannot infer a type from a schema.\n\nTo add an item action to your resource you can use the `item_actions` function. This must be a keyword list.\nThe keyword defines the name of the action. In addition, each keyword must define a map as a value. This map must at least\nprovide the module for the item action with the `module` key. The \"default\" Item Actions (Delete, Edit and Show) are passed as\nparameters to the item_actions and may be appended to your item actions.\n\nFurthermore, you can specify which ways of triggering the item action are enabled with the `only` key.\n\nThe only key must provide a list and accepts the following options\n- `:row` - display an icon for each element in the table that can trigger the Item Action for the corresponding element\n- `:index` - display a button at the top of the resource table, which triggers the Item Action for selected items\n- `:show` - display an icon in the show view that triggers the Item Action for the corresponding item\n\nThe following example shows how to define a soft delete item action and replace it with the default delete Item Action.","ref":"Backpex.ItemAction.html"},{"type":"behaviour","title":"Example - Backpex.ItemAction","doc":"defmodule DemoWeb.ItemAction.SoftDelete do\n      use BackpexWeb, :item_action\n\n      alias Backpex.Resource\n\n      @impl Backpex.ItemAction\n      def icon(assigns) do\n        ~H\"\"\"\n         \n        \"\"\"\n      end\n\n      @impl Backpex.ItemAction\n      def fields do\n        [\n          reason: %{\n            module: Backpex.Fields.Textarea,\n            label: \"Reason\",\n            type: :string\n          }\n        ]\n      end\n\n      @required_fields ~w[reason]a\n\n      @impl Backpex.ItemAction\n      def changeset(change, attrs) do\n        change\n        |> cast(attrs, @required_fields)\n        |> validate_required(@required_fields)\n      end\n\n      @impl Backpex.ItemAction\n      def label(_assigns), do: Backpex.translate(\"Delete\")\n\n      @impl Backpex.ItemAction\n      def confirm_label(_assigns), do: Backpex.translate(\"Delete\")\n\n      @impl Backpex.ItemAction\n      def cancel_label(_assigns), do: Backpex.translate(\"Cancel\")\n\n      @impl Backpex.ItemAction\n      def handle(socket, items, params) do\n        datetime = DateTime.truncate(DateTime.utc_now(), :second)\n        socket =\n          try do\n            {:ok, _items} =\n              Backpex.Resource.update_all(\n                socket.assigns,\n                items,\n                [set: [deleted_at: datetime, reason: Map.get(params, \"reason\")]],\n                \"deleted\"\n              )\n\n            socket\n            |> clear_flash()\n            |> put_flash(:info, \"Item(s) successfully deleted.\")\n          rescue\n              socket\n              |> clear_flash()\n              |> put_flash(:error, error)\n          end\n\n        {:noreply, socket}\n    end\n\n    # in your resource configuration file\n\n    @impl Backpex.LiveResource\n    def item_actions([show, edit, _delete]) do\n      Enum.concat([show, edit],\n        soft_delete: %{module: DemoWeb.ItemAction.SoftDelete}\n      )\n    end","ref":"Backpex.ItemAction.html#module-example"},{"type":"macro","title":"Backpex.ItemAction.__using__/1","doc":"Defines `Backpex.ItemAction` behaviour and provides default implementations.","ref":"Backpex.ItemAction.html#__using__/1"},{"type":"callback","title":"Backpex.ItemAction.cancel_label/1","doc":"cancel button label","ref":"Backpex.ItemAction.html#c:cancel_label/1"},{"type":"callback","title":"Backpex.ItemAction.changeset/3","doc":"The changeset to be used in the resource action. It may be used to validate form inputs.\n\nAdditional metadata is passed as a keyword list via the third parameter.\n\nThe list of metadata:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","ref":"Backpex.ItemAction.html#c:changeset/3"},{"type":"callback","title":"Backpex.ItemAction.confirm/1","doc":"This text is being displayed in the confirm dialog.\n\nThere won't be any confirmation when this function is not defined.","ref":"Backpex.ItemAction.html#c:confirm/1"},{"type":"callback","title":"Backpex.ItemAction.confirm_label/1","doc":"Confirm button label","ref":"Backpex.ItemAction.html#c:confirm_label/1"},{"type":"callback","title":"Backpex.ItemAction.fields/0","doc":"A list of fields to be displayed in the item action. See `Backpex.Field`. In addition you have to provide\na `type` for each field in order to support changeset generation.\n\nThe following fields are currently not supported:\n\n- `Backpex.Fields.BelongsTo`\n- `Backpex.Fields.HasMany`\n- `Backpex.Fields.HasManyThrough`\n- `Backpex.Fields.Upload`","ref":"Backpex.ItemAction.html#c:fields/0"},{"type":"callback","title":"Backpex.ItemAction.handle/3","doc":"Performs the action.","ref":"Backpex.ItemAction.html#c:handle/3"},{"type":"callback","title":"Backpex.ItemAction.icon/1","doc":"Action icon","ref":"Backpex.ItemAction.html#c:icon/1"},{"type":"callback","title":"Backpex.ItemAction.init_change/1","doc":"Initial change. The result will be passed to `Backpex.ItemAction.changeset/3` in order to generate a changeset.\n\nThis function is optional and can be used to use changesets with schemas in item actions. If this function\nis not provided a changeset will be generated automatically based on the provided types in `Backpex.ItemAction.fields/0`.","ref":"Backpex.ItemAction.html#c:init_change/1"},{"type":"callback","title":"Backpex.ItemAction.label/1","doc":"Action label (Show label on hover)","ref":"Backpex.ItemAction.html#c:label/1"},{"type":"module","title":"Backpex.ItemActions.Delete","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Delete.html"},{"type":"module","title":"Backpex.ItemActions.Edit","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Edit.html"},{"type":"module","title":"Backpex.ItemActions.Show","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Show.html"},{"type":"behaviour","title":"Backpex.Filter","doc":"The base behaviour for all filters. Injects also basic layout, form and delete button for a filters rendering.\n\nEnabling filters on a resources index view is a two step process:\n\n1. Add modules implementing one of the behaviors from the `Backpex.Filters` namespace to your project.\n  - We suggest to use a `MyAppWeb.Filters. ` convention.\n  - We implemented the `__using__` macro for the filters, injecting code like imports (e.g. `Ecto.Query`) and functions (e.g. `render/1`) into your module.\n2. Implement the `filters/0` callback on your resource.\n\nThe latter just returns a keyword list with the field names as keys and the filter module as values.\n\n    # in your resource configuration file\n    @impl Backpex.LiveResource\n    def filters, do: [\n        status: %{\n          module: MyAppWeb.Filters.EventStatusSelect\n        },\n        begins_at: %{\n          module: MyAppWeb.Filters.DateRange\n        },\n        published: %{\n          module: MyAppWeb.Filters.EventPublished\n        }\n      ]","ref":"Backpex.Filter.html"},{"type":"behaviour","title":"Custom filters - Backpex.Filter","doc":"Instead of using the pre-defined filters you can also define custom filters by using `Backpex.Filter` and implementing at least `label/0`, `query/3`, `render/1` and `render_form/1`.\n\nFor example purposes let's define a custom select filter:\n\n    defmodule MyApp.Filters.CustomSelectFilter do\n      use BackpexWeb, :filter\n\n      @impl Backpex.Filter\n      def label, do: \"Event status\"\n\n      @impl Backpex.Filter\n      def render(assigns) do\n        assigns = assign(assigns, :label, option_value_to_label(options(), assigns.value))\n\n        ~H\"\"\"\n        <%= @label %>\n        \"\"\"\n      end\n    \n      @impl Backpex.Filter\n      def render_form(assigns) do\n        ~H\"\"\"\n        <.form_field\n          type=\"select\"\n          selected={selected(@value)}\n          options={my_options()}\n          form={@form}\n          field={@field}\n          label=\"\"\n        />\n        \"\"\"\n      end\n      \n      @impl Backpex.Filter\n      def query(query, attribute, value) do\n        where(query, [x], field(x, ^attribute) == ^value)\n      end\n      \n      defp option_value_to_label(options, value) do\n        Enum.find_value(options, fn {option_label, option_value} ->\n          if option_value == value, do: option_label\n        end)\n      end\n      \n      defp my_options, do: [\n        {\"Select an option...\", nil},\n        {\"Open\", :open},\n        {\"Close\", :close},\n      ]\n\n      defp selected(\"\"), do: nil\n      defp selected(value), do: value\n    end","ref":"Backpex.Filter.html#module-custom-filters"},{"type":"behaviour","title":"Filter presets - Backpex.Filter","doc":"To define presets for your filters, you need to add a list of maps under the key of `:presets` to your filter in your LiveResource.\n\nEach of those maps has two keys:\n  1. `:label` – simply the String shown to the user\n  2. `:values` – a function with arity 0 that returns the values corresponding to your used filter\n\n> See the example below for `:values` return values for the default range and boolean filter\n\n\n    @impl Backpex.LiveResource\n    def filters, do: [\n        begins_at: %{\n          module: MyAppWeb.Filters.DateRange,\n          presets: [\n          %{\n            label: \"Last 7 Days\",\n            values: fn -> %{\n              \"start\" => Date.add(Date.utc_today(), -7),\n              \"end\" => Date.utc_today()\n            }\n            end\n          }\n        },\n        published: %{\n          module: MyAppWeb.Filters.EventPublished,\n          presets: [\n            %{\n              label: \"Both\",\n              values: fn -> [:published, :not_published] end\n            },\n            %{\n              label: \"Only published\",\n              values: fn -> [:published] end\n            }\n          ]\n        }\n      ]","ref":"Backpex.Filter.html#module-filter-presets"},{"type":"callback","title":"Backpex.Filter.can?/1","doc":"Defines whether the filter can be used or not.","ref":"Backpex.Filter.html#c:can?/1"},{"type":"callback","title":"Backpex.Filter.label/0","doc":"The filter's label.","ref":"Backpex.Filter.html#c:label/0"},{"type":"callback","title":"Backpex.Filter.query/3","doc":"The filter query that is executed if an option was selected.","ref":"Backpex.Filter.html#c:query/3"},{"type":"callback","title":"Backpex.Filter.render/1","doc":"Renders the filters selected value(s).","ref":"Backpex.Filter.html#c:render/1"},{"type":"callback","title":"Backpex.Filter.render_form/1","doc":"Renders the filters options form.","ref":"Backpex.Filter.html#c:render_form/1"},{"type":"behaviour","title":"Backpex.Filters.Boolean","doc":"The Boolean Filter renders one checkbox per given option, hence multiple options can apply at the same time.\nInstead of implementing a `query` callback, you need to define predicates for each option leveraging [`Ecto.Query.dynamic/2`](https://hexdocs.pm/ecto/Ecto.Query.html#dynamic/2).\n\n> Please note that only query elements will work as a predicate that also work in an [`Ecto.Query.where/3`](https://hexdocs.pm/ecto/Ecto.Query.html#where/3).\n\nIf none is selected, the filter does not change the query. If multiple options are selected they are logically reduced via `orWhere`.\n\nA really basic example is the following filter for a boolean column `:published`:\n\n    defmodule MyAppWeb.Filters.EventPublished do\n      use Backpex.Filters.Boolean\n\n      @impl Backpex.Filter\n      def label, do: \"Published?\"\n\n      @impl Backpex.Filters.Boolean\n      def options do\n        [\n          %{\n            label: \"Published\",\n            key: \"published\",\n            predicate: dynamic([x], x.published)\n          },\n          %{\n            label: \"Not published\",\n            key: \"not_published\",\n            predicate: dynamic([x], not x.published)\n          }\n        ]\n      end\n    end\n\n> #### `use Backpex.Filters.Boolean` {: .info}\n>\n> When you `use Backpex.Filters.Boolean`, the `Backpex.Filters.Boolean` module will set `@behavior Backpex.Filters.Boolean`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.\n> It will also implement the `Backpex.Filter.query` function to define a boolean query.","ref":"Backpex.Filters.Boolean.html"},{"type":"function","title":"Backpex.Filters.Boolean.find_option_label/2","doc":"","ref":"Backpex.Filters.Boolean.html#find_option_label/2"},{"type":"function","title":"Backpex.Filters.Boolean.maybe_query/2","doc":"","ref":"Backpex.Filters.Boolean.html#maybe_query/2"},{"type":"function","title":"Backpex.Filters.Boolean.option_value_to_label/2","doc":"","ref":"Backpex.Filters.Boolean.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.Boolean.options/0","doc":"The list of options for the select filter.","ref":"Backpex.Filters.Boolean.html#c:options/0"},{"type":"function","title":"Backpex.Filters.Boolean.predicates/1","doc":"","ref":"Backpex.Filters.Boolean.html#predicates/1"},{"type":"function","title":"Backpex.Filters.Boolean.query/4","doc":"","ref":"Backpex.Filters.Boolean.html#query/4"},{"type":"function","title":"Backpex.Filters.Boolean.render/1","doc":"","ref":"Backpex.Filters.Boolean.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Boolean.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Boolean.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Boolean.render_form/1","doc":"","ref":"Backpex.Filters.Boolean.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Boolean.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Boolean.html#render_form/1-attributes"},{"type":"behaviour","title":"Backpex.Filters.MultiSelect","doc":"The multi select filter behaviour. Renders a multi select box for the implemented `options/0` callback.\n`prompt/0` defines the label for the multi select box.\n\nSee the following example for an implementation of a multi select user filter.\n\n    defmodule MyAppWeb.Filters.MultiUserSelect do\n      use Backpex.Filters.MultiSelect\n\n      @impl Backpex.Filter\n      def label, do: \"User\"\n\n      @impl Backpex.Filters.MultiSelect\n      def prompt, do: \"Select user ...\"\n\n      @impl Backpex.Filters.MultiSelect\n      def options, do: [\n        {\"John Doe\", \"acdd1860-65ce-4ed6-a37c-433851cf68d7\"},\n        {\"Jane Doe\", \"9d78ce5e-9334-4a6c-a076-f1e72522de2\"}\n      ]\n    end\n\n> #### `use Backpex.Filters.MultiSelect` {: .info}\n>\n> When you `use Backpex.Filters.MultiSelect`, the `Backpex.Filters.MultiSelect` module will set `@behavior Backpex.Filters.Select`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.","ref":"Backpex.Filters.MultiSelect.html"},{"type":"function","title":"Backpex.Filters.MultiSelect.find_option_label/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#find_option_label/2"},{"type":"function","title":"Backpex.Filters.MultiSelect.maybe_query/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#maybe_query/2"},{"type":"function","title":"Backpex.Filters.MultiSelect.option_value_to_label/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.MultiSelect.options/0","doc":"The list of options for the multi select filter.","ref":"Backpex.Filters.MultiSelect.html#c:options/0"},{"type":"function","title":"Backpex.Filters.MultiSelect.query/3","doc":"","ref":"Backpex.Filters.MultiSelect.html#query/3"},{"type":"function","title":"Backpex.Filters.MultiSelect.render/1","doc":"","ref":"Backpex.Filters.MultiSelect.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.MultiSelect.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.MultiSelect.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.MultiSelect.render_form/1","doc":"","ref":"Backpex.Filters.MultiSelect.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.MultiSelect.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)\n* `prompt` (`:string`) (required)","ref":"Backpex.Filters.MultiSelect.html#render_form/1-attributes"},{"type":"behaviour","title":"Backpex.Filters.Range","doc":"Range filters render two input fields of the same type. Backpex offers the `:date`, `:datetime` and the `number` type.\n\nA basic implementation of a date range filter would look like this:\n\n    defmodule MyAppWeb.Filters.DateRange do\n      use Backpex.Filters.Range\n\n      @impl Backpex.Filters.Range\n      def type, do: :date\n\n      @impl Backpex.Filter\n      def label, do: \"Date Range (begins at)\"\n    end\n\n> Note that the query function is already implemented via `Backpex.Filters.Range`.\n\n> #### `use Backpex.Filters.Range` {: .info}\n>\n> When you `use Backpex.Filters.Range`, the `Backpex.Filters.Range` module will set `@behavior Backpex.Filters.Range`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.\n> It will also implement the `Backpex.Filter.query` function to define a range query.","ref":"Backpex.Filters.Range.html"},{"type":"function","title":"Backpex.Filters.Range.date?/1","doc":"","ref":"Backpex.Filters.Range.html#date?/1"},{"type":"function","title":"Backpex.Filters.Range.do_query/3","doc":"","ref":"Backpex.Filters.Range.html#do_query/3"},{"type":"function","title":"Backpex.Filters.Range.maybe_parse/3","doc":"","ref":"Backpex.Filters.Range.html#maybe_parse/3"},{"type":"function","title":"Backpex.Filters.Range.maybe_parse_range/3","doc":"","ref":"Backpex.Filters.Range.html#maybe_parse_range/3"},{"type":"function","title":"Backpex.Filters.Range.parse_float_or_int/1","doc":"","ref":"Backpex.Filters.Range.html#parse_float_or_int/1"},{"type":"function","title":"Backpex.Filters.Range.query/4","doc":"","ref":"Backpex.Filters.Range.html#query/4"},{"type":"function","title":"Backpex.Filters.Range.range_input_set/1","doc":"","ref":"Backpex.Filters.Range.html#range_input_set/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.range_input_set/1","doc":"* `form` (`:any`) (required)\n* `type` (`:atom`) (required)\n* `value` (`:any`) (required)","ref":"Backpex.Filters.Range.html#range_input_set/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render/1","doc":"","ref":"Backpex.Filters.Range.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.render/1","doc":"* `value` (`:map`) (required)","ref":"Backpex.Filters.Range.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render_form/1","doc":"","ref":"Backpex.Filters.Range.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `type` (`:atom`) (required)","ref":"Backpex.Filters.Range.html#render_form/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render_type/1","doc":"","ref":"Backpex.Filters.Range.html#render_type/1"},{"type":"callback","title":"Backpex.Filters.Range.type/0","doc":"The type return value defines the rendered input fields of the range filter.","ref":"Backpex.Filters.Range.html#c:type/0"},{"type":"behaviour","title":"Backpex.Filters.Select","doc":"The select filter behaviour. Renders a select box for the implemented `options/0` and `prompt/0` callbacks.\n`prompt/0` defines the key for the `nil` value added as first option.\n\nSee the following example for an implementation of an event status filter.\n\n    defmodule MyAppWeb.Filters.EventStatusSelect do\n      use Backpex.Filters.Select\n\n      @impl Backpex.Filter\n      def label, do: \"Event status\"\n\n      @impl Backpex.Filters.Select\n      def prompt, do: \"Select an option...\"\n\n      @impl Backpex.Filters.Select\n      def options, do: [\n        {\"Open\", :open},\n        {\"Close\", :close},\n      ]\n\n      @impl Backpex.Filter\n      def query(query, attribute, value) do\n          where(query, [x], field(x, ^attribute) == ^value)\n      end\n    end\n\n> #### `use Backpex.Filters.Select` {: .info}\n>\n> When you `use Backpex.Filters.Select`, the `Backpex.Filters.Select` module will set `@behavior Backpex.Filters.Select`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.","ref":"Backpex.Filters.Select.html"},{"type":"function","title":"Backpex.Filters.Select.option_value_to_label/2","doc":"","ref":"Backpex.Filters.Select.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.Select.options/0","doc":"The list of options for the select filter.","ref":"Backpex.Filters.Select.html#c:options/0"},{"type":"callback","title":"Backpex.Filters.Select.prompt/0","doc":"The select's default option.","ref":"Backpex.Filters.Select.html#c:prompt/0"},{"type":"function","title":"Backpex.Filters.Select.query/3","doc":"","ref":"Backpex.Filters.Select.html#query/3"},{"type":"function","title":"Backpex.Filters.Select.render/1","doc":"","ref":"Backpex.Filters.Select.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Select.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Select.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Select.render_form/1","doc":"","ref":"Backpex.Filters.Select.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Select.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)\n* `prompt` (`:string`) (required)","ref":"Backpex.Filters.Select.html#render_form/1-attributes"},{"type":"function","title":"Backpex.Filters.Select.selected/1","doc":"","ref":"Backpex.Filters.Select.html#selected/1"},{"type":"behaviour","title":"Backpex.Metric","doc":"Behaviour implemented by all metrics.\n\nMetrics are info boxes for your resources displaying key indicators prominently on the index view in your application.\nAn example could be to show the current total of all orders received today. You may create your own metrics by\nimplementing this behaviour.","ref":"Backpex.Metric.html"},{"type":"callback","title":"Backpex.Metric.format/2","doc":"","ref":"Backpex.Metric.html#c:format/2"},{"type":"function","title":"Backpex.Metric.load_data_for_visible/5","doc":"Load and append the corresponding metric value(s) via the module's query for\nevery metric in the given list. Query's are only performed if metrics are\nmarked as visible for the give live resource.","ref":"Backpex.Metric.html#load_data_for_visible/5"},{"type":"function","title":"Backpex.Metric.metric_box_class/1","doc":"Builds string of css classes for basic metric box","ref":"Backpex.Metric.html#metric_box_class/1"},{"type":"function","title":"Backpex.Metric.metrics_visible?/2","doc":"Determine if metrics are visible for given live_resource.","ref":"Backpex.Metric.html#metrics_visible?/2"},{"type":"callback","title":"Backpex.Metric.query/3","doc":"","ref":"Backpex.Metric.html#c:query/3"},{"type":"callback","title":"Backpex.Metric.render/1","doc":"Used to render the metric as a heex template on the index views.","ref":"Backpex.Metric.html#c:render/1"},{"type":"module","title":"Backpex.Metrics.Value","doc":"Value metrics display only a single value. This value is generated from the current index query by applying the given\naggregate function. The selected value is processed by the specified formatting function and output in the frontend.","ref":"Backpex.Metrics.Value.html"},{"type":"module","title":"Options - Backpex.Metrics.Value","doc":"* `:module` - Defines the module to handle the metric.\n  * `:label` - Label text to define a headline for the metric.\n  * `:select` - Dynamic query expression defining the column to select. This is usually an aggregate function.\n  * `:format` - Optional format function to post-process the selected value from the database to display in frontend.\n  * `:class` - Optional extra css classes to be passed to the metric box.","ref":"Backpex.Metrics.Value.html#module-options"},{"type":"module","title":"Example - Backpex.Metrics.Value","doc":"In the following example we have a live resource `products` with a value `quantity`. We use the `select` option here\nto pass an aggregate function that adds up the `quantity` value of all products currently active in the index view.\n\n    @impl Backpex.LiveResource\n    def metrics do\n      [\n        total_quantity: %{\n          module: Backpex.Metrics.Value,\n          label: \"In Stock\",\n          class: \"w-1/3\",\n          select: dynamic([i], sum(i.quantity)),\n          format: fn value ->\n            Integer.to_string(value) <> \" Products\"\n          end\n        }\n      ]\n    end","ref":"Backpex.Metrics.Value.html#module-example"},{"type":"function","title":"Backpex.Metrics.Value.format/2","doc":"Formats the selected data to display in frontend.","ref":"Backpex.Metrics.Value.html#format/2"},{"type":"function","title":"Backpex.Metrics.Value.query/3","doc":"Performs database select to query the value of the metric","ref":"Backpex.Metrics.Value.html#query/3"},{"type":"function","title":"Backpex.Metrics.Value.render/1","doc":"","ref":"Backpex.Metrics.Value.html#render/1"},{"type":"function","title":"Attributes - Backpex.Metrics.Value.render/1","doc":"* `metric` (`:any`) (required) - the metric to be rendered.","ref":"Backpex.Metrics.Value.html#render/1-attributes"},{"type":"exception","title":"Backpex.ForbiddenError","doc":"Raised when action can not be performed due to missing permission.\n\nIf you are seeing this error, you should check if you have the permission necessary to perform the action.","ref":"Backpex.ForbiddenError.html"},{"type":"exception","title":"Backpex.NoResourceError","doc":"Raised when resource can not be found.\n\nIf you are seeing this error, you should check if you provided the correct identifier for the requested resource.","ref":"Backpex.NoResourceError.html"},{"type":"extras","title":"Installation","doc":"# Installation","ref":"installation.html"},{"type":"extras","title":"Prerequisites - Installation","doc":"Make sure you have a running phoenix application with [Tailwind CSS](https://tailwindcss.com/) and [daisyUI](https://daisyui.com/docs/install/) installed.\n\n> #### Important {: .info}\n>\n> Backpex currently only supports daisyUI light mode.\n\nBackpex currently depends on [Ecto](https://hexdocs.pm/ecto/Ecto.html). Therefore there has to be a running\necto repository.","ref":"installation.html#prerequisites"},{"type":"extras","title":"Add Backpex to list of dependencies - Installation","doc":"In your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    ...\n    {:backpex, path: \"backpex_path\"}\n  ]\nend\n```","ref":"installation.html#add-backpex-to-list-of-dependencies"},{"type":"extras","title":"Add Backpex files to tailwind content - Installation","doc":"In your `tailwind.config.js`:\n\n```js\ncontent: ['./path_to_deps/backpex/**/*.*ex']\n```","ref":"installation.html#add-backpex-files-to-tailwind-content"},{"type":"extras","title":"Setup formatter - Installation","doc":"We recommend to add Backpex to the list of dependencies in your `.formatter.exs`.\n\n```elixir\n# my_app/.formatter.exs\n[\n  import_deps: [:backpex]\n]\n```","ref":"installation.html#setup-formatter"},{"type":"extras","title":"Create layout - Installation","doc":"Backpex does not ship a predefined layout by default. Instead it exposes components you\nmay use to build your own layout. You could also partly use Backpex components. For example\nyou are able to define your own sidebar navigation in our app shell component.\n\nPlace the layout file in your `lib/myapp_web/templates/layout` directory.\n\nYou can find all Backpex components in the `lib/backpex/components` directory.\n\nIf you do not want to put effort into creating your own layout, feel free to use this layout (`admin.html.heex`) as a starting point:\n\n> The `Backpex.HTML.Layout.app_shell` component accepts a boolean `fluid` to determine if a `LiveResource` should be rendered full width. Our default is the definition of the `fluid?` option in a `LiveResource`, but feel free to change this behavior in your layout.\n\n```elixir\n \n  <:topbar>\n     \n     \n      <:label>\n         \n      </:label>\n       \n        <.link navigate=\"/\" class=\"my-1 flex justify-between px-4 py-2 text-sm text-red-600 hover:bg-gray-100\">\n           Logout \n           \n        </.link>\n       \n     \n  </:topbar>\n  <:sidebar>\n     \n        Your Resource\n     \n     \n      <:label>Your Sidebar Section</:label>\n       \n          Your nested Resource\n       \n     \n  </:sidebar>\n   \n  <%= @inner_content %>\n \n```\n\nYou can now create and configure the corresponding resources.","ref":"installation.html#create-layout"},{"type":"extras","title":"Translations","doc":"# Translations\n\nYou may configure translator functions in your application config:\n\n```elixir\nconfig :backpex, :translator_function, {MyAppWeb.Helpers, :translate_backpex}\n\nconfig :backpex, :error_translator_function, {MyAppWeb.ErrorHelpers, :translate_error}\n```\n\nThe first one is being used to translate general strings. The second one is being used to translate\n(changeset) errors.","ref":"translations.html"},{"type":"extras","title":"Using Gettext - Translations","doc":"If you want to use Gettext, the translator functions should look like this:\n\n```elixir\n# MyAppWeb.Helpers\n\ndef translate_backpex({msg, opts}) do\n  if count = opts[:count] do\n    Gettext.dngettext(MyAppWeb.Gettext, \"backpex\", msg, msg, count, opts)\n  else\n    Gettext.dgettext(MyAppWeb.Gettext, \"backpex\", msg, opts)\n  end\nend\n\n# MyAppWeb.ErrorHelpers\n\ndef translate_error({msg, opts}) do\n  if count = opts[:count] do\n    Gettext.dngettext(DemoWeb.Gettext, \"errors\", msg, msg, count, opts)\n  else\n    Gettext.dgettext(DemoWeb.Gettext, \"errors\", msg, opts)\n  end\nend\n```\n\nStore this example template as `priv/gettext/backpex.pot`. It contains all translations used by Backpex.\n\n```","ref":"translations.html#using-gettext"},{"type":"extras","title":"This file is a PO Template file. - Translations","doc":"msgid \"\"\nmsgstr \"\"\n\nmsgid \"New %{resource}\"\nmsgstr \"\"\n\nmsgid \"Edit %{resource}\"\nmsgstr \"\"\n\nmsgid \"Delete\"\nmsgstr \"\"\n\nmsgid \"Edit\"\nmsgstr \"\"\n\nmsgid \"Save\"\nmsgstr \"\"\n\nmsgid \"Cancel\"\nmsgstr \"\"\n\nmsgid \"Search\"\nmsgstr \"\"\n\nmsgid \"Filters\"\nmsgstr \"\"\n\nmsgid \"Are you sure you want to delete %{count} items?\"\nmsgstr \"\"\n\nmsgid \"Are you sure you want to delete the item?\"\nmsgstr \"\"\n\nmsgid \"New %{resource} has been created successfully.\"\nmsgstr \"\"\n\nmsgid \"%{resource} has been edited successfully.\"\nmsgstr \"\"\n\nmsgid \"%{resource} has been deleted successfully.\"\nmsgstr \"\"\n\nmsgid \"%{count} %{resources} have been deleted successfully.\"\nmsgstr \"\"\n\nmsgid \"An error occurred while deleting the %{resource}!\"\nmsgstr \"\"\n\nmsgid \"An error occurred while deleting %{count} %{resources}!\"\nmsgstr \"\"\n\nmsgid \"The item is used elsewhere.\"\nmsgstr \"\"\n\nmsgid \"The items are used elsewhere.\"\nmsgstr \"\"\n\nmsgid \"You are not allowed to do this!\"\nmsgstr \"\"\n\nmsgid \"Upload a file\"\nmsgstr \"\"\n\nmsgid \"or drag and drop\"\nmsgstr \"\"\n\nmsgid \"too large\"\nmsgstr \"\"\n\nmsgid \"too many files\"\nmsgstr \"\"\n\nmsgid \"unacceptable file type\"\nmsgstr \"\"\n\nmsgid \"clear\"\nmsgstr \"\"\n\nmsgid \"No %{resources} found\"\nmsgstr \"\"\n\nmsgid \"Try a different search term.\"\nmsgstr \"\"\n\nmsgid \"Try a different filter setting or clear all filters.\"\nmsgstr \"\"\n\nmsgid \"Get started by creating new %{resources}.\"\nmsgstr \"\"\n\nmsgid \"Select options...\"\nmsgstr \"\"\n\nmsgid \"No options found\"\nmsgstr \"\"\n\nmsgid \"Select all\"\nmsgstr \"\"\n\nmsgid \"Deselect all\"\nmsgstr \"\"\n\nmsgid \"Show more\"\nmsgstr \"\"\n\nmsgid \"Items %{from} to %{to}\"\nmsgstr \"\"\n\nmsgid \"total\"\nmsgstr \"\"\n\nmsgid \"There are errors in the form.\"\nmsgstr \"\"\n\nmsgid \"Add entry\"\nmsgstr \"\"\n\nmsgid \"Apply\"\nmsgstr \"\"\n\nmsgid \"Attach %{resource}\"\nmsgstr \"\"\n\nmsgid \"Choose %{resource} ...\"\nmsgstr \"\"\n\nmsgid \"Toggle metrics\"\nmsgstr \"\"\n\nmsgid \"Toggle columns\"\nmsgstr \"\"\n\nmsgid \"Select all items\"\nmsgstr \"\"\n\nmsgid \"Close alert\"\nmsgstr \"\"\n\nmsgid \"Select item with id: %{id}\"\nmsgstr \"\"\n\nmsgid \"Clear %{name} filter\"\nmsgstr \"\"\n\nmsgid \"Edit relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Detach relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Error in relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Close modal\"\nmsgstr \"\"\n\nmsgid \"Unselect %{label}\"\nmsgstr \"\"\n\nmsgid \"selected\"\nmsgstr \"\"\n```","ref":"translations.html#this-file-is-a-po-template-file"},{"type":"extras","title":"Full-Text Search","doc":"# Full-Text Search\n\nBackpex allows you to perform full-text searches on resources. It uses the built-in PostgreSQL full-text search functionality.","ref":"full_text_search.html"},{"type":"extras","title":"Create a Generated Column - Full-Text Search","doc":"Backpex forces you to create a generated column to use the full-text search functionality. It must contain a tsvector that is generated from all the columns that you want to be considered when searching. You are free to choose a name for this column.\n\nBelow is an example of a generated column for a movie review resource with a title column and an overview column. Both columns should be searchable.\n\n```elixir\n# in the database up migration\n\nexecute(\"\"\"\nALTER TABLE film_reviews\n  ADD COLUMN generated_tsvector tsvector\n  GENERATED ALWAYS AS (\n    to_tsvector('english', coalesce(title, '') || ' ' || coalesce(overview, ''))\n  ) STORED;\n\"\"\")\n```\n\nYou can also concat multiple tsvectors in the generated column. This is useful if the table contains data in\ndifferent languages. We recommend that you specify the language when using the `to_tsvector` function. Otherwise\nthe default language will be used.","ref":"full_text_search.html#create-a-generated-column"},{"type":"extras","title":"Create an Index - Full-Text Search","doc":"To increase the speed of full-text searches, especially for resources with large amounts of data, you should create\nan index on the generated column created in the previous step.\n\nWe strongly recommend that you use a GIN index, as it makes full-text searches really fast.\nThe disadvantage is that a GIN index takes up a lot of disk space, so if you are limited in disk space,\nfeel free to use a GiST index instead.\n\n```elixir\n# in the database up migration\n\nexecute(\"\"\"\nCREATE INDEX film_reviews_search_idx ON film_reviews USING GIN(generated_tsvector);\n\"\"\")\n```\n    \n> #### Important {: .info}\n>\n> Note that you must explicitly define up and down migrations. Otherwise, the index cannot be dropped.\n\n```elixir\n# in the database down migration\n\nexecute(\"\"\"\nDROP INDEX film_reviews_search_idx;\n\"\"\")\n\ndrop table(:film_reviews)\n```\n\nTo enable full-text search, you need to specify the name of the generated column in the live resource of the\ncorresponding resource.\n\n```elixir\n# in the live resource\n\nuse Backpex.LiveResource,\n  full_text_search: :generated_tsvector\n```","ref":"full_text_search.html#create-an-index"},{"type":"extras","title":"Upgrading to v0.2","doc":"# Upgrading to v0.2","ref":"v0-2.html"},{"type":"extras","title":"Bump Your Deps - Upgrading to v0.2","doc":"Update Backpex to the latest version:\n\n```elixir\n  defp deps do\n    [\n      {:backpex, \"~> 0.2.0\"}\n    ]\n  end\n```","ref":"v0-2.html#bump-your-deps"},{"type":"extras","title":"Pass `assigns` to `init_change` functions - Upgrading to v0.2","doc":"We change the arity of the `init_change/0` function to `init_change/1` for resource and item actions.\n\nThe param will be the assigns. This adds more ways to construct an initial change.\n\nIf you had such a function in your resource or item action:\n\n```elixir\n@impl Backpex.ItemAction\ndef init_change() do\n  # construct init change\nend\n```\n\nYou need to change it to this:\n\n```elixir\n@impl Backpex.ItemAction\ndef init_change(_assigns) do\n  # construct init change\nend\n```","ref":"v0-2.html#pass-assigns-to-init_change-functions"},{"type":"extras","title":"Change arity of changeset functions - Upgrading to v0.2","doc":"See [Pull Request](https://github.com/naymspace/backpex/pull/94).\n\nWe are introducing a new way to pass metadata to changeset functions. Previously, we supported changeset functions with\ndifferent arities to optionally pass the `assigns` and `target` name to changesets.\n\nWith this release, we require the arity of all changeset functions you provide to be `3`.\n\nThe metadata, previously passed as additional parameters, is now passed as a keyword list to changesets as the third parameter.\n\nCurrently we pass the following metadata to changesets:\n\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call\n\n\nWhen you previously had a LiveResource and Schema that looked like the following:\n\n```elixir\ndefmodule MyAppWeb.UserLive do\n  use Backpex.LiveResource,\n      ...\n      update_changeset: &MyApp.User.changeset/2,\n      create_changeset: &MyApp.User.changeset/2,\nend\n\n\ndefmodule MyApp.User do\n  ...\n\n  def changeset(user, attrs) do\n      ...\n  end\nend\n```\n\nYou have to change it to this:\n\n```elixir\ndefmodule MyAppWeb.UserLive do\n  use Backpex.LiveResource,\n    ...\n    update_changeset: &MyApp.User.changeset/3,\n    create_changeset: &MyApp.User.changeset/3,\nend\n\n\ndefmodule MyApp.User do\n  ...\n\n  def changeset(user, attrs, metadata) do\n    # fetch assigns from metadata\n    assigns = Keyword.get(metadata, :assigns)\n\n    # fetch target from metadata\n    assigns = Keyword.get(metadata, :target)\n\n    ...\n  end\nend\n```\n\nThis change applies to Resource and Item Actions as well.\n\nFor example:\n\n```elixir\ndefmodule MyApp.EmailResourceAction\n  use Backpex.ResourceAction\n\n  @impl Backpex.ResourceAction\n  def changeset(change, attrs, _metadata \\\\ []) do\n    ...\n  end\nend\n```","ref":"v0-2.html#change-arity-of-changeset-functions"},{"type":"extras","title":"Update prompt option - Upgrading to v0.2","doc":"With v0.2 we are updating the prompt option for fields. This affects to the following fields: `BelongsTo`, `Select`, `HasMany`, `ManyToMany` and `MultiSelect`. \nThe `prompt` option can be raw text or a function that takes the assigns and returns text. \nWe no longer support adding additional options.\n\nIf you previously had a field that looked like the following:\n\n```elixir\ndef fields do\n  [\n    user: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Author\",\n      prompt: [key: \"Please select an author\", disabled: true],\n      ...\n    },\n  ]\nend\n```\n\nYou need to change it to the following:\n\n```elixir\ndef fields do\n  [\n    user: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Author\",\n      prompt: \"Please select an author\",\n      ...\n    },\n  ]\nend\n```","ref":"v0-2.html#update-prompt-option"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,48]}}